      subroutine avergf(m,nxf,nyf,nzf,nspecf,
     &                  presf, temprf, 
     &                  cncf,coldf,avconf,avgtmf,deltf,time,ndate,
     &                  tmo3f,no3ptf,co3avf,ifine)
c
c     *** (c) Copr. 1992  Systems Applications, Inc.  San Rafael, CA
c
c$Log: avergf.f,v $
c  Revision 1.8  1999/12/21  19:27:25  tcm
c  Renamed com3 include file to comd3.
c
c  Revision 1.7  1998/11/20  18:42:05  tcm
c  corrected format of message on line 133
c
c  Revision 1.6  1998/11/17  17:40:35  ara
c  Included errlog.cmd file to introduce ierrlg variable
c  Directed warning message to diag file and to log file (ierrlg)
c
c  Revision 1.5  1998/11/04  01:06:02  tcm
c  Removed max o3 average calculation
c  ,
c  ,
c
c  Revision 1.4  1995/04/26  00:35:48  tcm
c  	set dimension of avconf array to mxspec instead of nspecf
c
c  Revision 1.3  94/07/27  09:12:23  tcm
c  Added code to optionally calculate rolling o3 average and keep
c  track of maximum hourly average o3.
c  
c  Revision 1.2  94/02/10  20:50:32  tcm
c  Cosmetic revisions to code by gem, syw, tcm
c  
c
c
c
c  subroutine average computes the average concentrations using
c  the rectangle rule for the time integrations.
c
c  when  m=1 we begin the time average
c        m=2 we continue to generate the average
c        m=3 we conclude the averaging
c
      save
c
      include 'parm.cmd'
      include 'parchm.cmd'
      include 'parfin.cmd'
      include 'comuam.cmd'
      include 'comchem.cmd'
      include 'comd3.cmd'
      include 'ppmcon.cmd'
      include 'avo3con.cmd'
      include 'errlog.cmd'
c
      dimension tmo3f(nsteps), no3ptf(nsteps), co3avf(nxf,nyf,nsteps)
      dimension cncf(nxf,nyf,nspecf,nzf), coldf(nxf,nyf,nspecf),
     &          avconf(nxf,nyf,mxspec), presf(nxf,nyf,nzf),
     &          temprf(nxf,nyf,nzf)
c
      write(*,4000) time,ndate,deltf,m
c
      if (m.eq.1) then
        avgtmf=0.0
        do 10 k=1,nspecf
          do 9 j=1,nyf
            do 8 i=1,nxf
              avconf(i,j,k)=0.0
    8       continue
    9     continue
   10   continue
      endif
c
c     add in cold arrays to avcon arrays
c
      if (m .gt. 1) then
        avgtmf=avgtmf+deltf
        do 112 k=1,nspecf
          do 111 j=2,nyf-1
            do 110 i=2,nxf-1
              avconf(i,j,k)=avconf(i,j,k)+0.5*deltf*coldf(i,j,k)
  110       continue
  111     continue
  112   continue
c
c     add in current instantenous concentrations
c
        do 290 k=1,nspecf
          do 280 j=2,nyf-1
            do 270 i=2,nxf-1
              avconf(i,j,k)=avconf(i,j,k)+0.5*deltf*cncf(i,j,k,1)*
     &                      temprf(i,j,1)*cpfac/(presf(i,j,1)*273.)
  270       continue
  280     continue
  290   continue
      endif
c
c     close out averaging
c
      if (m.eq.3) then
        do 312 k=1,nspecf
          do 311 j=2,nyf-1
            do 310 i=2,nxf-1
              avconf(i,j,k)=avconf(i,j,k)/avgtmf
  310       continue
  311     continue
  312   continue
      endif
c
c     load cncf into cold arrays for next time step
c
      do 350 k=1,nspecf
        do 345 j=2,nyf-1
          do 340 i=2,nxf-1
            coldf(i,j,k) = cncf(i,j,k,1)*
     &                     temprf(i,j,1)*cpfac/(presf(i,j,1)*273.)
  340     continue
  345   continue
  350 continue
c
c  keep track of o3 concs for running average
c
      if (lmxo3) then
        thrs = aint(time/100.) + amod(time,100.)/60.
        write(*,*) 'thrs, time = ', thrs, time
c
c  save current o3 concs in array for future averages
c
        if (no3spf(ifine) .gt. 0) then
          tt1 = tmo3f(no3spf(ifine))
        else
          tt1 = -1.
        endif
        if (thrs-tt1 .ge. dtavg/60.) then
          no3spf(ifine) = no3spf(ifine) + 1
          if (no3spf(ifine) .gt. nsteps) then
            write(*,*) '***WARNING***:  exceeded o3 steps, skipping'
            write(8,*) '***WARNING***:  exceeded o3 steps, skipping'
            write(ierrlg,'(i4,1x,a,a)') 212,'***WARNING***:  exceeded',
     &                 ' o3 steps, skipping' 
            go to 485
          else
            tmo3f(no3spf(ifine)) = thrs
          endif
          write(*,*) 'Placing o3 av concs in location ',
     &               no3spf(ifine)
          do 480 j=2,nyf-1
            do 470 i=2,nxf-1
              co3avf(i,j,no3spf(ifine)) = coldf(i,j,ko3)
  470       continue
  480     continue
        endif
c
  485   continue
c
      endif
c
 4000 format(' enter avergf ',f10.1,i10,f10.2,'  m = ',i3)
 4100 format(' leave avergf')
      return
      end
