c
c    common /balanc/
c
c
c$Log: balanc.cmd,v $
c  Revision 1.2  1994/02/10  21:03:35  tcm
c  Cosmetic revisions to code by gem, syw, tcm
c
c
c       -- used for keeping track of mass fluxes in and out
c          of the modeled region
c
c       -- added variables xbcflo and xtpflo (tcm, 5/6/93)
c
c          fluxes are calculated during each hour for the coarse grid 
c          and for each fine (nested) grid.  separate cumulative 
c          fluxes are retained also.  in the following list of 
c          variables, the first is the coarse grid variable, the 
c          second is the cumulative coarse grid variable, the third 
c          is the fine grid variable, and the fourth is the cumulative
c          fine grid variable.
c
c          bcflow, bcflcu, fbcflo, fbcflc -- fluxes across lateral 
c             boundaries.  separate totals are kept for in and out
c             and for each of the four boundaries.
c
c          xbcflo, xtpflo, xbcflc, xtpflc -- fluxes across lateral 
c             boundaries of each fine grid calculated from coarse 
c             grid variables
c
c          tpflow, tpflcu, ftpflo, ftpflc -- fluxes across the top
c             boundary.  separate totals are kept for in and out.
c
c          ptflow, ptflcu, fptflo, fptflc -- flux of emissions
c             from elevated sources (other than pig treated sources).
c
c          eflow, eflcu, feflo, feflc -- flux of area source emissions.
c
c          dpflow, dpflcu, fdpflo, fdpflc -- deposition flux
c
c          pgflow, pgflcu, fpgflo, fpgflc -- mass added to grid 
c             when plume segments are released into grid.
c
c          gpflow, gpflcu, fgpflo, fgpflc -- mass removed from grid
c             when plume segments are released into grid.
c
c          pgemfl, pgemcu, fpgemf, fpgemc -- mass emitted into 
c             plume segments for pig treatment.  over the entire
c             course of a run, this variable should be 
c             approximately equal to the difference of the previous
c             two for corresponding variables for inert species.
c             (e.g., pgemcu = pgflcu - gpflcu)
c 
c          pxflow, pxflcu -- plume segment mass exiting the coarse
c             grid and hence never to be seen again.  this is not
c             kept track of on fine grids.
c
c          tmas, ftmas -- total mass in the coarse grid or a fine
c             grid at the current time.
c
c          xtmas -- total mass in a fine grid calculated from
c             coarse grid variables.
c
      common /balanc/ bcflow(mxspec,2,4), tpflow(mxspec,2), 
     &            ptflow(mxspec), eflow(mxspec), dpflow(mxspec),
     &            pgflow(mxspec), gpflow(mxspec), pgemfl(mxspec),
     &            pxflow(mxspec),
     &            bcflcu(mxspec,2,4), tpflcu(mxspec,2), 
     &            ptflcu(mxspec), eflcu(mxspec), dpflcu(mxspec),
     &            pgflcu(mxspec), gpflcu(mxspec), pgemcu(mxspec),
     &            pxflcu(mxspec), tmas(mxspec),
     &            fbcflo(mxspec,2,4,maxfin), ftpflo(mxspec,2,maxfin), 
     &            xbcflo(mxspec,2,4,maxfin), xtpflo(mxspec,2,maxfin), 
     &            fptflo(mxspec,maxfin), feflo(mxspec,maxfin),
     &            fdpflo(mxspec,maxfin),
     &            fpgflo(mxspec,maxfin), fgpflo(mxspec,maxfin), 
     &            fpgemf(mxspec,maxfin),
     &            fbcflc(mxspec,2,4,maxfin), ftpflc(mxspec,2,maxfin), 
     &            xbcflc(mxspec,2,4,maxfin), xtpflc(mxspec,2,maxfin), 
     &            fptflc(mxspec,maxfin), feflc(mxspec,maxfin),
     &            fdpflc(mxspec,maxfin),
     &            fpgflc(mxspec,maxfin), fgpflc(mxspec,maxfin), 
     &            fpgemc(mxspec,maxfin),
     &            ftmas(mxspec,maxfin), xtmas(mxspec,maxfin)
c
