      subroutine caltoj(idate,jdate)
C
C     *** (c) Copr. 1992  Systems Applications, Inc.  San Rafael, CA
c
c$Log: caltoj.f,v $
c  Revision 1.5  1998/11/16  18:43:28  ara
c  Made modifications to error messages format
c
c  Revision 1.4  1998/11/10  00:08:20  ara
c  Included file errlog.cmd to introduce ierrlg variable
c  Directed message errors to diag file and to log file (ierrlg)
c
c  Revision 1.3  1998/11/04  01:06:18  tcm
c  Fixed leap year calculation for year 2000
c  Added validity checks
c  Date range assumed to be from 1951 to 2050
c
c  Revision 1.2  94/02/10  20:50:52  tcm
c  Cosmetic revisions to code by gem, syw, tcm
c  
c
c
c   convert a YYMMDD or YYYYMMDD type date to a five digit Julian date
c
      include 'errlog.cmd'
      dimension ntab(12)
      data ntab/31,28,31,30,31,30,31,31,30,31,30,31/
c
      iyr = idate/10000
      if (iyr .gt. 99) then
        if (iyr .lt. 1951 .or. iyr .gt. 2050) then
          write(*,*) 'Invalid year: ', iyr
          write(*,*) 'Converted from input date ', idate
          write(*,*) 'Terminating in caltoj'
          write(8,*) 'Invalid year: ',iyr
          write(8,*) 'Converted from input date ', idate
          write(8,*) 'Terminating in caltoj'
          write(ierrlg,*) 1064, ' Invalid year: ',iyr
          write(ierrlg,*) 'Converted from input date ',idate
          write(ierrlg,*) 'Terminating in caltoj'
          stop
        endif
      endif
c
c  extract month and check validity
c
      imo = (idate - iyr*10000)/100
      if (imo .lt. 1 .or. imo .gt. 12) then
        write(*,*) 'Invalid month: ', imo
        write(*,*) 'Converted from input date ', idate
        write(*,*) 'Terminating in caltoj'
        write(8,*) 'Invalid month: ', imo
        write(8,*) 'Converted form input date ', idate
        write(8,*) 'Terminating in caltoj'
        write(ierrlg,*) 1063,' Invalid month: ', imo
        write(ierrlg,*) 'Converted from input date ', idate
        write(ierrlg,*) 'Terminating in caltoj'
        stop
      endif
c     
      if (mod(iyr,4) .eq. 0) then
        ntab(2) = 29
      else
        ntab(2) = 28
      endif
c
c  extract day of month and check validity
c
      iday = idate - iyr*10000 - imo*100
      if (iday .lt. 1 .or. iday .gt. ntab(imo)) then
        write(*,*) 'Invalid day of month: ', iday
        write(*,*) 'Converted from input date ', idate
        write(*,*) 'Terminating in caltoj'
        write(8,*) 'Invalid day of month: ', iday
        write(8,*) 'Converted from input date ', idate
        write(8,*) 'Terminating in caltoj'
        write(ierrlg,*) 1065,' Invalid day of month: ',iday
        write(ierrlg,*) 'Converted from input date ',idate
        write(ierrlg,*) 'Terminating in caltoj'
        stop
      endif
c
      nsum = 0
      do 100 ii=1,imo-1
        nsum = nsum + ntab(ii)
  100 continue
      nday = nsum + iday
c
      if (iyr .gt. 99) iyr = mod(iyr,100)
      jdate = iyr*1000 + nday
      return
      end
