      subroutine chema(nospec,nors,hh,hr,rate,rp,lerror)
c
c   *** Generated from DFG's VBChemG software, Dongfen Gao, 5/18/1999
c
c
c$Log: chem_fst.f,v $
c Revision 1.1  1999/06/23  23:45:01  dfg
c Initial revision
c
c

      include  'parchm.cmd'
      include  'comchem.cmd'
      logical lerror,lin
      DIMENSION  rate(mxspec), rp(mxspec,mxspec)
      dimension  hh(mxspec), hr(mxrads)
      common /idcell/icell,jcell,kcell,tmchm
      REAL NO, NO2, O3, OLE, PAR, TOL, XYL, HCHO, ACET, ETH, 
     & CRES, MGLY, OPEN, PNA, PAN, CO, HNO2, H2O2, HNO3, ISOP, 
     & SO2, SULF, MEOH, ETOH, MTBE, NPHN, ALDX, IOLE, PANX, CH4, 
     & NTR, ISPD, PHCHO, PACET, O1D, O, NO3, N2O5, HO2, OH, C2O3, 
     & CXO3, XO2, XO2N, TO2, ROR, CRO
c*************************************************
c     INPUT OF CONCENTRATION DATA -- PPM UNIT
c*************************************************
      SO2  = 0.
      SULF = 0.
      MEOH = 0.
      ETOH = 0.
      ISOP = 0.
      ISPD = 0.
      MTBE = 0.
      NPHN = 0.
      NO = HH(kNO)
      NO2 = HH(kNO2)
      O3 = HH(kO3)
      OLE = HH(kOLE)
      PAR = HH(kPAR)
      TOL = HH(kTOL)
      XYL = HH(kXYL)
      HCHO = HH(kHCHO)
      ACET = HH(kACET)
      ETH = HH(kETH)
      CRES = HH(kCRES)
      MGLY = HH(kMGLY)
      OPEN = HH(kOPEN)
      PNA = HH(kPNA)
      PAN = HH(kPAN)
      CO = HH(kCO)
      HNO2 = HH(kHNO2)
      H2O2 = HH(kH2O2)
      HNO3 = HH(kHNO3)
      IF (LISOP) ISOP = HH(kISOP)
      IF (LSO2) SO2 = HH(kSIV)
      IF (LSO2) SULF = HH(kSULF)
      IF (LMEOH) MEOH = HH(kMEOH)
      IF (LETOH) ETOH = HH(kETOH)
      IF (LMTBE) MTBE = HH(KMTBE)
      IF (LNPHN) NPHN = HH(KNPHN)
      ALDX = HH(kALDX)
      IOLE = HH(kIOLE)
      PANX = HH(kPANX)
      CH4 = HH(kCH4)
      IF (LNITR) NTR = HH(kNITR)
      IF (LISOP) ISPD = HH(kISPD)
      PHCHO = 0.
      PACET = 0.
      If (LPHCH) Then
        PHCHO = HH(KPHCH)
        HCHO = HCHO + PHCHO
        PACET = HH(KPACT)
        ACET = ACET + PACET
      End If
      FPF = PHCHO / HCHO
      FSF = 1. - FPF
      FPA = PACET / ACET
      FSA = 1. - FPA
      O1D = HR(kO1D)
      O = HR(kO)
      NO3 = HR(kNO3)
      N2O5 = HR(kN2O5)
      HO2 = HR(kHO2)
      OH = HR(kOH)
      C2O3 = HR(kC2O3)
      CXO3 = HR(kCXO3)
      XO2 = HR(kXO2)
      XO2N = HR(kXO2N)
      TO2 = HR(kTO2)
      ROR = HR(kROR)
      CRO = HR(kCRO)
      kso2 = ksiv
      kntr = knitr
c
c This is radical solver routine and coded by Dongfen Gao, SAI, July 1998.
c  In this routine, the radical will be solved and the rate and
c    Jacobian for fast species will be calculated.
c
      nitmax = 50
      xtol = 0.01
      lss=.true.
c
c
c---- the radical solver now------
c
c    Solver O1D and O first.
c
      Sink =   - rk(10)  - rk(11)*H2O
      Source = 1.*rk(9)*O3
      hr(ko1d) = -Source/Sink
      o1d = hr(ko1d)
c
      Sink =   - rk(2)  - rk(4)*NO2  - rk(5)*NO2  - rk(6)*NO
     &   - rk(40)*HCHO  - rk(42)*ACET  - rk(56)*OLE  - rk(60)*ETH
     &   - rk(75)*ISOP  - rk(90)*ALDX  - rk(94)*IOLE
      Source = 1.*rk(1)*NO2 +1.*rk(8)*O3 +1.*rk(10)*O1D
     &  +.89*rk(14)*NO3 +.5*rk(96)*IOLE*O3
      hr(ko) = -Source/Sink
      o = hr(ko)
c
c    Solver NO3 and N2O5 Next.
c
      liter = 0
      xxtol = xtol
 100  continue
      lerror=.false.
      liter = liter + 1
c
      ibeg=kno3
      iend=kn2o5
      call radjrat(nospec,hh,hr,rate,rp)
      call colpivot (ibeg,iend,mxspec,rp,rate,ier)
c
      if (ier.eq.0) then
        lerror=.true.
        write(*,*) 'error in radical concentration calculation'
        write(*,*) 'in colpivot, matrix of equations is singular'
        write(*,*) 'solve N2O5 & NO3'
        write(*,*) 'ier,liter,nitmax= ',ier,liter,nitmax
        call flush(6)
        Stop
      endif
      tmpmax = 0.
      do 200 l = ibeg,iend
        tmphr = hr(l)
        if (hr(l).gt.1.0e-9) then
           err=abs(rate(l)/hr(l))
        else
           err=abs(rate(l))
        endif
        hr(l) = tmphr - Rate(l)
        if (err.gt.tmpmax) Then
          tmpmax = err
          itmp = l
        endif
         if (hr(l).le. 0.0) hr(l)=tmphr/10.
 200  continue
c
      if (tmpmax.gt.xxtol) then
        if (liter .eq. 5) xxtol = xxtol*10.
        if (liter.le.nitmax) go to 100
        write(*,*) 'error in radical calculation in chem --'
        write(*,*) 'increase nitmax'
        write(*,*) 'ier,liter,nitmax= ',ier,liter,nitmax
        write(*,1300) (n,hr(n),n=1,mxrads)
        write(*,1400) (n,rk(n),n=1,94)
        write(*,*) 'icell,jcell,kcell,tmchm'
        write(*,*) icell,jcell,kcell,tmchm
        call flush(6)
        lerror =.true.
        Stop
      endif
c
      no3 = hr(kno3)
      n2o5 = hr(kn2o5)
c
c---- radicals NO3 and N2O5 converged.
c     now Solve HO2, OH, C2O3, XO2, XO2N together
c
      liter = 0
      xxtol = xtol
 210  continue
      lerror=.false.
      liter = liter + 1
c
      ibeg=kho2
      iend=kxo2n
      call radjrat(nospec,hh,hr,rate,rp)
      call colpivot (ibeg,iend,mxspec,rp,rate,ier)
c
      if (ier.eq.0) then
        lerror=.true.
        write(*,*) 'error in radical concentration calculation'
        write(*,*) 'in colpivot, matrix of equations is singular'
        write(*,*) 'HO2,OH,C2O3,CXO3,XO2,XO2N'
        write(*,*) 'ier,liter,nitmax= ',ier,liter,nitmax
        call flush(6)
        Stop
      endif
      tmpmax = 0.
      do 220 l = ibeg,iend
        tmphr = hr(l)
        if (hr(l).gt.1.0e-9) then
           err=abs(rate(l)/hr(l))
        else
           err=abs(rate(l))
        endif
        hr(l) = tmphr - Rate(l)
        if (err.gt.tmpmax) Then
          tmpmax = err
          itmp = l
        endif
         if (hr(l).le. 0.0) hr(l)=tmphr/10.
 220  continue
c
      if (tmpmax.gt.xxtol) then
        if (liter .eq. 5) xxtol = xxtol*10.
        if (liter.le.nitmax) go to 210
        write(*,*) 'error in radical calculation in chem --'
        write(*,*) 'increase nitmax'
        write(*,*) 'ier,liter,nitmax= ',ier,liter,nitmax
        write(*,1300) (n,hr(n),n=1,mxrads)
        write(*,1400) (n,rk(n),n=1,94)
        write(*,*) 'icell,jcell,kcell,tmchm'
        write(*,*) icell,jcell,kcell,tmchm
        call flush(6)
        lerror =.true.
        Stop
      endif
c
      ho2 = hr(kho2)
      oh = hr(koh)
      c2o3 = hr(kc2o3)
      cxo3 = hr(kcxo3)
      xo2 = hr(kxo2)
      xo2n = hr(kxo2n)
c
c---- radicals HO2, OH, C2O3, XO2, XO2N converged.
c   and now Solve ROR,TO2,and CRO separately
c
      Sink =   - 0.98*rk(53)  - rk(54)  - rk(55)*NO2
      Source = .76*rk(52)*PAR*OH
      hr(kror) = -Source/Sink
      ror = hr(kror)
c
      Sink =   - rk(64)*NO  - rk(65)
      Source = .56*rk(63)*TOL*OH +.3*rk(72)*OH*XYL
      hr(kto2) = -Source/Sink
      to2 = hr(kto2)
c
      Sink =   - rk(68)*NO2
      Source = .4*rk(66)*OH*CRES +1.*rk(67)*CRES*NO3
      hr(kcro) = -Source/Sink
      cro = hr(kcro)
c
c---- all radicals have been solved and now we calculate
c      rate and Jacobian for fast species.
c
      call fastrate_a(nospec,hh,hr,rate)
      call fastjac_a(nospec,hh,hr,rp)
c
c
c---------formats------------------------------------------------------
 1000 format(1x,
     1         '*** error in radical concentration calculations in chem',
     2    //,2x,'       ier     liter    nitmax',/,2x,3i10)
 1300 format(1x,'    hr   ',/,(1x,i4,e12.5))
 1400 format(1x,'    rk   ',/,(1x,i4,e12.5))
 1500 format(1x,' jac--for i=  ',i3,/,(6e12.5))
c----------------------------------------------------------------------
c
      return
      end
      SUBROUTINE FASTRATE_a(NOSPEC,HH,HR,RATE)
      INCLUDE  'parchm.cmd'
      INCLUDE  'comchem.cmd'
      DIMENSION  RATE(MXSPEC), HH(MXSPEC), HR(MXRADS)
      REAL NO, NO2, O3, OLE, PAR, TOL, XYL, HCHO, ACET, ETH, 
     & CRES, MGLY, OPEN, PNA, PAN, CO, HNO2, H2O2, HNO3, ISOP, 
     & SO2, SULF, MEOH, ETOH, MTBE, NPHN, ALDX, IOLE, PANX, CH4, 
     & NTR, ISPD, PHCHO, PACET, O1D, O, NO3, N2O5, HO2, OH, C2O3, 
     & CXO3, XO2, XO2N, TO2, ROR, CRO
c*************************************************
c     INPUT OF CONCENTRATION DATA -- PPM UNIT
c*************************************************
      SO2  = 0.
      SULF = 0.
      MEOH = 0.
      ETOH = 0.
      ISOP = 0.
      ISPD = 0.
      MTBE = 0.
      NPHN = 0.
      NO = HH(KNO)
      NO2 = HH(KNO2)
      O3 = HH(KO3)
      OLE = HH(KOLE)
      PAR = HH(KPAR)
      TOL = HH(KTOL)
      XYL = HH(KXYL)
      HCHO = HH(KHCHO)
      ACET = HH(KACET)
      ETH = HH(KETH)
      CRES = HH(KCRES)
      MGLY = HH(KMGLY)
      OPEN = HH(KOPEN)
      PNA = HH(KPNA)
      PAN = HH(KPAN)
      CO = HH(KCO)
      HNO2 = HH(KHNO2)
      H2O2 = HH(KH2O2)
      HNO3 = HH(KHNO3)
      IF (LISOP) ISOP = HH(KISOP)
      IF (LSO2) SO2 = HH(KSIV)
      IF (LSO2) SULF = HH(KSULF)
      IF (LMEOH) MEOH = HH(KMEOH)
      IF (LETOH) ETOH = HH(KETOH)
      IF (LMTBE) MTBE = HH(KMTBE)
      IF (LNPHN) NPHN = HH(KNPHN)
      ALDX = HH(KALDX)
      IOLE = HH(KIOLE)
      PANX = HH(KPANX)
      CH4 = HH(KCH4)
      IF (LNITR) NTR = HH(KNITR)
      IF (LISOP) ISPD = HH(KISPD)
      PHCHO = 0.
      PACET = 0.
      If (LPHCH) Then
        PHCHO = HH(KPHCH)
        PACET = HH(KPACT)
      End If
      O1D = HR(KO1D)
      O = HR(KO)
      NO3 = HR(KNO3)
      N2O5 = HR(KN2O5)
      HO2 = HR(KHO2)
      OH = HR(KOH)
      C2O3 = HR(KC2O3)
      CXO3 = HR(KCXO3)
      XO2 = HR(KXO2)
      XO2N = HR(KXO2N)
      TO2 = HR(KTO2)
      ROR = HR(KROR)
      CRO = HR(KCRO)
      kso2 = ksiv
      kntr = knitr
c
c     *** zero out rate for state species. 
c 
       do 100 i=1,nospec
          rate(i) = 0. 
 100   continue
c
c      Calculating the rate for state species
c
      Sink =   - rk(3)*O3  - rk(6)*O  - rk(15)*NO3
     &   - rk(20)*NO  - rk(20)*NO  - rk(21)*NO2*H2O
     &   - rk(22)*OH  - rk(28)*HO2  - rk(46)*C2O3
     &   - rk(64)*TO2  - rk(79)*XO2  - rk(81)*XO2N
     &   - rk(98)*CXO3
      Source = 1.*rk(1)*NO2 +1.*rk(4)*O*NO2
     &  +.11*rk(14)*NO3 +1.*rk(16)*NO3*NO2
     &  +1.*rk(23)*HNO2 +1.*rk(25)*HNO2*HNO2
     &  +1.*rk(64)*TO2*NO +.2*rk(109)*NO2*ISOP
      Rate(kNO) = Source + Sink*NO
      Sink =   - rk(1)  - rk(4)*O  - rk(5)*O
     &   - rk(7)*O3  - rk(16)*NO3  - rk(17)*NO3
     &   - rk(21)*NO*H2O  - rk(26)*OH  - rk(29)*HO2
     &   - rk(47)*C2O3  - rk(55)*ROR  - rk(68)*CRO
     &   - rk(99)*CXO3  - rk(109)*ISOP
      Source = 1.*rk(3)*O3*NO +1.*rk(6)*O*NO
     &  +.89*rk(14)*NO3 +2.*rk(15)*NO3*NO
     &  +1.*rk(16)*NO3*NO2 +1.*rk(19)*N2O5
     &  +2.*rk(20)*NO*NO +1.*rk(24)*OH*HNO2
     &  +1.*rk(25)*HNO2*HNO2 +1.*rk(28)*HO2*NO
     &  +1.*rk(30)*PNA +1.*rk(31)*OH*PNA
     &  +1.*rk(46)*C2O3*NO +1.*rk(48)*PAN
     &  +1.*rk(59)*NO3*OLE +.2*rk(78)*NO3*ISOP
     &  +1.*rk(79)*XO2*NO +1.*rk(97)*IOLE*NO3
     &  +1.*rk(98)*CXO3*NO +1.*rk(100)*PANX
     &  +1.*rk(103)*PANX*OH
      Rate(kNO2) = Source + Sink*NO2
      Sink =   - rk(3)*NO  - rk(7)*NO2  - rk(8)
     &   - rk(9)  - rk(12)*OH  - rk(13)*HO2
     &   - rk(58)*OLE  - rk(62)*ETH  - rk(71)*OPEN
     &   - rk(77)*ISOP  - rk(96)*IOLE  - rk(106)*ISPD
      Source = 1.*rk(2)*O +.33*rk(50)*C2O3*HO2
     &  +.33*rk(102)*CXO3*HO2
      Rate(kO3) = Source + Sink*O3
c
      RETURN
      END
      SUBROUTINE fastjac_a(NOSPEC,HH,HR,JAC)
      INCLUDE  'parchm.cmd'
      INCLUDE  'comchem.cmd'
      DIMENSION  JAC(MXSPEC,MXSPEC), HH(MXSPEC),HR(MXRADS)
      REAL JAC
      REAL NO, NO2, O3, OLE, PAR, TOL, XYL, HCHO, ACET, ETH, 
     & CRES, MGLY, OPEN, PNA, PAN, CO, HNO2, H2O2, HNO3, ISOP, 
     & SO2, SULF, MEOH, ETOH, MTBE, NPHN, ALDX, IOLE, PANX, CH4, 
     & NTR, ISPD, PHCHO, PACET, O1D, O, NO3, N2O5, HO2, OH, C2O3, 
     & CXO3, XO2, XO2N, TO2, ROR, CRO
c*************************************************
c     INPUT OF CONCENTRATION DATA -- PPM UNIT
c*************************************************
      SO2  = 0.
      SULF = 0.
      MEOH = 0.
      ETOH = 0.
      ISOP = 0.
      ISPD = 0.
      MTBE = 0.
      NPHN = 0.
      NO = HH(KNO)
      NO2 = HH(KNO2)
      O3 = HH(KO3)
      OLE = HH(KOLE)
      PAR = HH(KPAR)
      TOL = HH(KTOL)
      XYL = HH(KXYL)
      HCHO = HH(KHCHO)
      ACET = HH(KACET)
      ETH = HH(KETH)
      CRES = HH(KCRES)
      MGLY = HH(KMGLY)
      OPEN = HH(KOPEN)
      PNA = HH(KPNA)
      PAN = HH(KPAN)
      CO = HH(KCO)
      HNO2 = HH(KHNO2)
      H2O2 = HH(KH2O2)
      HNO3 = HH(KHNO3)
      IF (LISOP) ISOP = HH(KISOP)
      IF (LSO2) SO2 = HH(KSIV)
      IF (LSO2) SULF = HH(KSULF)
      IF (LMEOH) MEOH = HH(KMEOH)
      IF (LETOH) ETOH = HH(KETOH)
      IF (LMTBE) MTBE = HH(KMTBE)
      IF (LNPHN) NPHN = HH(KNPHN)
      ALDX = HH(KALDX)
      IOLE = HH(KIOLE)
      PANX = HH(KPANX)
      CH4 = HH(KCH4)
      IF (LNITR) NTR = HH(KNITR)
      IF (LISOP) ISPD = HH(KISPD)
      PHCHO = 0.
      PACET = 0.
      If (LPHCH) Then
        PHCHO = HH(KPHCH)
        PACET = HH(KPACT)
      End If
      O1D = HR(KO1D)
      O = HR(KO)
      NO3 = HR(KNO3)
      N2O5 = HR(KN2O5)
      HO2 = HR(KHO2)
      OH = HR(KOH)
      C2O3 = HR(KC2O3)
      CXO3 = HR(KCXO3)
      XO2 = HR(KXO2)
      XO2N = HR(KXO2N)
      TO2 = HR(KTO2)
      ROR = HR(KROR)
      CRO = HR(KCRO)
      kso2 = ksiv
      kntr = knitr
c
c     *** zero out jac 
c 
       do 200 i=1,nospec
         do 100 j=1,nospec
           jac(i, j) = 0. 
 100     continue
 200   continue
c
c      Calculating the Jacobian for fast Species
c
      JAC(kNO, kNO) =  - rk(3)*O3 - rk(6)*O
     $  - rk(15)*NO3 - rk(20)*NO
     $  - rk(20)*NO - rk(20)*NO
     $  - rk(20)*NO - rk(21)*NO2*H2O
     $  - rk(22)*OH - rk(28)*HO2
     $  - rk(46)*C2O3 - rk(64)*TO2
     $  - rk(79)*XO2 - rk(81)*XO2N
     $  - rk(98)*CXO3 +1.*rk(64)*TO2
      JAC(kNO, kNO2) =  - rk(21)*NO*H2O +1.*rk(1)
     $  +1.*rk(4)*O +1.*rk(16)*NO3
     $  +.2*rk(109)*ISOP
      JAC(kNO, kO3) =  - rk(3)*NO
      JAC(kNO2, kNO) =  - rk(21)*NO2*H2O +1.*rk(3)*O3
     $  +1.*rk(6)*O +2.*rk(15)*NO3
     $  +2.*rk(20)*NO +2.*rk(20)*NO
     $  +1.*rk(28)*HO2 +1.*rk(46)*C2O3
     $  +1.*rk(79)*XO2 +1.*rk(98)*CXO3
      JAC(kNO2, kNO2) =  - rk(1) - rk(4)*O
     $  - rk(5)*O - rk(7)*O3
     $  - rk(16)*NO3 - rk(17)*NO3
     $  - rk(21)*NO*H2O - rk(26)*OH
     $  - rk(29)*HO2 - rk(47)*C2O3
     $  - rk(55)*ROR - rk(68)*CRO
     $  - rk(99)*CXO3 - rk(109)*ISOP
     $  +1.*rk(16)*NO3
      JAC(kNO2, kO3) =  - rk(7)*NO2 +1.*rk(3)*NO
      JAC(kO3, kNO) =  - rk(3)*O3
      JAC(kO3, kNO2) =  - rk(7)*O3
      JAC(kO3, kO3) =  - rk(3)*NO - rk(7)*NO2
     $  - rk(8) - rk(9)
     $  - rk(12)*OH - rk(13)*HO2
     $  - rk(58)*OLE - rk(62)*ETH
     $  - rk(71)*OPEN - rk(77)*ISOP
     $  - rk(96)*IOLE - rk(106)*ISPD
c
      RETURN
      END
