      subroutine ckhgt(ifget,nxd,nyd,nxg,nyg,nzg,hnew,
     &                 ifine,nxf,nyf,nzf,hnewf)
c
c  This subroutine checks whether the fine grid's layer heights match
c  the coarse grid's layer heights.
c
c$Log: ckhgt.f,v $
c Revision 1.7  1998/11/20  23:30:35  tcm
c Corrected format of error message on line 99
c
c Revision 1.6  1998/11/20  19:03:35  tcm
c corrected formats of error messages.
c
c Revision 1.5  1998/11/16  17:52:57  ara
c *** empty log message ***
c
c Revision 1.4  1998/11/16  17:51:45  ara
c Made small modifications to error messages format
c
c Revision 1.3  1998/11/06  22:25:02  ara
c Included file errlog.cmd to introduce ierrlg variable
c Directed error messages to screen,diag file and log file (ierrlg)
c
c Revision 1.2  1996/06/17  17:59:01  tcm
c Inserted log messages into header
c
c
c  nhf= coarse grid size / fine grid size
c
c  nzf: number of layers in fine grid layer related to coarse grid layer
c
      include 'parm.cmd'
      include 'parfin.cmd'
      include 'deffin.cmd'
      include 'errlog.cmd'
c
      logical flag/.false./
      dimension hnewf(nxf,nyf,nzf)
      dimension hnew(nxd,nyd,nzg)
c
c  calculate some parameters relating the two grids
c
      if (ifget .eq. 0) then
        hrat = 1./float(nhf(ifine))
        xset = float(ixfb(ifine))
        yset = float(jyfb(ifine))
      else
        hrat = float(nhf(ifget))/float(nhf(ifine))
        xset = float((ixfb(ifine)-ixfb(ifget))*nhf(ifget)+2)
        yset = float((jyfb(ifine)-jyfb(ifget))*nhf(ifget)+2)
      endif
      flag = .false.
c
      do 300 j= jyfb(ifine),jyfe(ifine)
        jy1= nhf(ifine)*(j-jyfb(ifine)+1)+1
        jy0= jy1-nhf(ifine)+1
c
        do 200 i= ixfb(ifine),ixfe(ifine)
          ix1= nhf(ifine)*(i-ixfb(ifine)+1)+1
          ix0= ix1-nhf(ifine)+1
c
          do 101 ify= jy0,jy1
            jc = (float(ify)-1.5)*hrat + yset
c
            do 100 ifx= ix0,ix1
              ic = (float(ifx)-1.5)*hrat + xset
c              
              do 60 k =1,nzg
                do 50 kf =1,nzf 
                  if( abs(hnew(ic,jc,k)-hnewf(ifx,ify,kf))
     &                                       .lt. 0.0005) then
c
                    if( flag ) then
                      if( kf.ne.kvmap(k,ifine) ) then
                        write(*,*)'error! fine grid layers do not' 
     &                    //' match prior layer definition'
                        write(*,*)'Grid #',ifget
                        write(*,*)'coarse i,j,k,hnew: ',i,j,k,
     &                            hnew(i,j,k)
                        write(*,*)'Grid #',ifine
                        write(*,*)'fine ifx,ify,kf,hnewf: ',ifx,ify,kf,
     &                          hnewf(ifx,ify,kf)
                        write(*,*) 'Prior mapping, layer ',k,
     &                             ' to layer ',kvmap(k,ifine)
                       write(8,*)'error! fine grid layers do not'
     &                    //' match prior layer definition'
                        write(8,*)'Grid #',ifget
                        write(8,*)'coarse i,j,k,hnew: ',i,j,k,
     &                            hnew(i,j,k)
                        write(8,*)'Grid #',ifine
                        write(8,*)'fine ifx,ify,kf,hnewf: ',ifx,ify,kf,
     &                          hnewf(ifx,ify,kf)
                        write(8,*) 'Prior mapping, layer ',k,
     &                             ' to layer ',kvmap(k,ifine)
                        write(ierrlg,'(i4,1x,a,a)') 
     &                           1040,'error! fine grid layers do not',
     &                           ' match prior layer definition'
                        write(ierrlg,*)'Grid #',ifget
                        write(ierrlg,*)'coarse i,j,k,hnew: ',i,j,k,
     &                            hnew(i,j,k)
                        write(ierrlg,*)'Grid #',ifine
                        write(ierrlg,*)
     &                          'fine ifx,ify,kf,hnewf: ',ifx,ify,kf,
     &                          hnewf(ifx,ify,kf)
                        write(ierrlg,*) 'Prior mapping, layer ',k,
     &                             ' to layer ',kvmap(k,ifine)
                        stop
                      endif
                    endif
c
                    kvmap(k,ifine) = kf
                    go to 60
                  endif 
   50           continue
c
                if( kvmap(k,ifine).eq.0 ) then
                  write(*,*)'error! No match found for coarse grid' 
     &                //' layer height'
                  write(*,*)'Grid #',ifget
                  write(*,*)'coarse i,j,k,hnew: ',i,j,k,hnew(i,j,k)
                  write(*,*)'Grid #',ifine
                  write(*,*)'fine ifx,ify,hnewf: ',ifx,ify,
     &                          (hnewf(ifx,ify,kf),kf=1,nzf)
                  write(8,*)'error! No match found for coarse grid'
     &                //' layer height'
                  write(8,*)'Grid #',ifget
                  write(8,*)'coarse i,j,k,hnew: ',i,j,k,hnew(i,j,k)
                  write(8,*)'Grid #',ifine
                  write(8,*)'fine ifx,ify,hnewf: ',ifx,ify,
     &                          (hnewf(ifx,ify,kf),kf=1,nzf)
                  write(ierrlg,'(i4,1x,a,a)') 
     &                   1041,'error! No match found for coarse grid',
     &                   ' layer height'
                  write(ierrlg,*)'Grid #',ifget
                  write(ierrlg,*)'coarse i,j,k,hnew: ',i,j,k,hnew(i,j,k)
                  write(ierrlg,*)'Grid #',ifine
                  write(ierrlg,*)'fine ifx,ify,hnewf: ',ifx,ify,
     &                          (hnewf(ifx,ify,kf),kf=1,nzf)
                  stop
                endif
c
   60         continue
c
              flag= .true.
c
  100       continue
  101     continue
c
  200   continue
c
  300 continue
c
      return 
      end
