      subroutine cumprt(time,ndate)
C
C     *** (c) Copr. 1992  Systems Applications, Inc.  San Rafael, CA
c
c$Log: cumprt.f,v $
c  Revision 1.2  1994/02/10  20:54:18  tcm
c  Cosmetic revisions to code by gem, syw, tcm
c
c
C
c
c...Print coarse grid cumulative mass fluxes at the
c...end of a run.  RRS 6/21/91
c
      include 'parm.cmd'
      include 'parchm.cmd'
      include 'parfin.cmd'
      include 'comuam.cmd'
      include 'balanc.cmd'
c
c  print cumulative mass flux summary (only for species
c  to appear on average file)
c
      write(8,2025) time, ndate
      do 410 l=1,navspc,2
        linspc = kavspc(l)
        if (l .lt. navspc) lins2 = kavspc(l+1)
        if (l .eq. navspc) then
          write(8,2010) mavspc(l)
          fnet = bcflcu(linspc,1,1) - bcflcu(linspc,2,1)
          write(8,2020) bcflcu(linspc,1,1), eflcu(linspc), 
     &                  bcflcu(linspc,2,1), ptflcu(linspc),
     &                  fnet, dpflcu(linspc)
          fnetw = bcflcu(linspc,1,4) - bcflcu(linspc,2,4)
          fnett = tpflcu(linspc,1) - tpflcu(linspc,2)
          fnete = bcflcu(linspc,1,3) - bcflcu(linspc,2,3)
          write(8,2030) bcflcu(linspc,1,4), 
     &                  tpflcu(linspc,1), bcflcu(linspc,1,3),
     &                  gpflcu(linspc), bcflcu(linspc,2,4),
     &                  tpflcu(linspc,2), bcflcu(linspc,2,3),
     &                  pgflcu(linspc), fnetw, fnett, fnete,
     &                  pgemcu(linspc), pxflcu(linspc)
          fnet = bcflcu(linspc,1,2) - bcflcu(linspc,2,2)
          write(8,2035) bcflcu(linspc,1,2), bcflcu(linspc,2,2), 
     &                  tmas(linspc), fnet
        else
          write(8,2110) mavspc(l), mavspc(l+1)
          fnet = bcflcu(linspc,1,1) - bcflcu(linspc,2,1)
          fnet2 = bcflcu(lins2,1,1) - bcflcu(lins2,2,1)
          write(8,2120) bcflcu(linspc,1,1), eflcu(linspc), 
     &          bcflcu(lins2,1,1), eflcu(lins2),
     &          bcflcu(linspc,2,1), ptflcu(linspc),
     &          bcflcu(lins2,2,1), ptflcu(lins2),
     &          fnet, dpflcu(linspc), fnet2, dpflcu(lins2)
          fnetw = bcflcu(linspc,1,4) - bcflcu(linspc,2,4)
          fnett = tpflcu(linspc,1) - tpflcu(linspc,2)
          fnete = bcflcu(linspc,1,3) - bcflcu(linspc,2,3)
          fnetw2 = bcflcu(lins2,1,4) - bcflcu(lins2,2,4)
          fnett2 = tpflcu(lins2,1) - tpflcu(lins2,2)
          fnete2 = bcflcu(lins2,1,3) - bcflcu(lins2,2,3)
          write(8,2130) bcflcu(linspc,1,4), 
     &                  tpflcu(linspc,1), bcflcu(linspc,1,3),
     &                  gpflcu(linspc), 
     &                  bcflcu(lins2,1,4), 
     &                  tpflcu(lins2,1), bcflcu(lins2,1,3),
     &                  gpflcu(lins2),
     &                  bcflcu(linspc,2,4),
     &                  tpflcu(linspc,2), bcflcu(linspc,2,3),
     &                  pgflcu(linspc),
     &                  bcflcu(lins2,2,4),
     &                  tpflcu(lins2,2), bcflcu(lins2,2,3),
     &                  pgflcu(lins2),
     &                  fnetw, fnett, fnete, pgemcu(linspc),
     &                  fnetw2, fnett2, fnete2, pgemcu(lins2),
     &                  pxflcu(linspc), pxflcu(lins2)
          fnet = bcflcu(linspc,1,2) - bcflcu(linspc,2,2)
          fnet2 = bcflcu(lins2,1,2) - bcflcu(lins2,2,2)
          write(8,2135) bcflcu(linspc,1,2), bcflcu(lins2,1,2),
     &                  bcflcu(linspc,2,2), tmas(linspc), 
     &                  bcflcu(lins2,2,2), tmas(lins2), fnet, fnet2
        endif
        write(8,2040)
  410 continue        
c
      return
c
c  formats
c
 2010 format(1x,'Spec = ',a10,2x,'North')
 2020 format(13x,'In  ',1pe10.3,15x,'Srf emiss ',e10.3,/,
     &       13x,'Out ',e10.3,15x,'Elv emiss ',e10.3,/,
     &       13x,'Net ',e10.3,15x,'Depostn   ',e10.3,/)
 2025 format(//,1x,'Cumulative Mass flux summary in moles for',
     &     ' coarse grid at',f8.2,i8,':',/)
 2030 format(8x,'West',8x,'Top',8x,'East',6x,'PIG Mass: ',
     &       /,1x,'In  ',1pe10.3,2x,e10.3,2x,
     &       e10.3,3x,'Grid out  ',e10.3,/,
     &       1x,'Out ',e10.3,2x,e10.3,2x,e10.3,3x,
     &       'Plume in  ',e10.3,/,
     &       1x,'Net ',e10.3,2x,e10.3,2x,e10.3,3x,'Plume ems ',e10.3,
     &       /,42x,'Exited    ',e10.3,/,20x,'South')
 2035 format(13x,'In  ',1pe10.3,/,
     &       13x,'Out ',e10.3,15x,'Tot mass  ',e10.3,/,
     &       13x,'Net ',e10.3,e10.3,/)
 2040 format(1x,126(1h-))
 2110 format(1x,'Spec = ',a10,2x,'North',38x,'| ','Spec = ',
     &       a10,2x,'North')
 2120 format(13x,'In  ',1pe10.3,15x,'Srf emiss ',e10.3,1x,'|',
     &       13x,'In  ',e10.3,15x,'Srf emiss ',e10.3,/,
     &       13x,'Out ',e10.3,15x,'Elv emiss ',e10.3,1x,'|',
     &       13x,'Out ',e10.3,15x,'Elv emiss ',e10.3,/,
     &       13x,'Net ',e10.3,15x,'Depostn   ',e10.3,1x,'|',
     &       13x,'Net ',e10.3,15x,'Depostn   ',e10.3,/,63x,'|')
 2130 format(8x,'West',8x,'Top',8x,'East',6x,'PIG Mass: ',
     &       12x,'|',8x,'West',8x,'Top',8x,'East',6x,
     &       'PIG Mass: ',/,1x,'In  ',1pe10.3,2x,e10.3,2x,
     &       e10.3,3x,'Grid out  ',e10.3,1x,'|',
     &       1x,'In  ',e10.3,2x,e10.3,2x,
     &       e10.3,3x,'Grid out  ',e10.3,/,
     &       1x,'Out ',e10.3,2x,e10.3,2x,e10.3,3x,
     &       'Plume in  ',e10.3,1x,'|',
     &       1x,'Out ',e10.3,2x,e10.3,2x,e10.3,3x,
     &       'Plume in  ',e10.3,/,
     &       1x,'Net ',e10.3,2x,e10.3,2x,e10.3,
     &       3x,'Plume ems ',e10.3,1x,'|',
     &       1x,'Net ',e10.3,2x,e10.3,2x,e10.3,
     &       3x,'Plume ems ',e10.3,
     &       /,42x,'Exited    ',e10.3,1x,'|',42x,'Exited    ',e10.3,
     &       /,20x,'South',38x,'|',20x,'South')
 2135 format(13x,'In  ',1pe10.3,36x,'|',
     &       13x,'In  ',e10.3,/,
     &       13x,'Out ',e10.3,15x,'Tot mass  ',e10.3,1x,'|',
     &       13x,'Out ',e10.3,15x,'Tot mass  ',e10.3,/,
     &       13x,'Net ',e10.3,36x,'|',
     &       13x,'Net ',e10.3,/,63x,'|')
      end
