      subroutine dmppig(mmx,mmy,mmz,npuff,ifgnow,ig,jg,kg,
     &                   ifn,jfn,kfn,dy,idiag)
c
c     *** (c) Copr. 1992  Systems Applications, Inc.  San Rafael, CA
c
c-----this subroutine dumps the mass in all plumes to external file
c     for use in extracting BC's.
c     routine emulates puffdmp.f with idump = 4 for all puffs.
c
c$Log: dmppig.f,v $
c Revision 1.3  1999/12/21  19:27:54  tcm
c Renamed com3 include file to comd3.
c
c Revision 1.2  1996/06/17  17:59:01  tcm
c Inserted log messages into header
c
c
c     gem 95/12/12
c
      include'parm.cmd'
      include 'parchm.cmd'
      include'parfin.cmd'
      include'comuam.cmd'
      include'comd3.cmd'
      include'com1f.cmd'
      include'pigpen.cmd'
      include'pigdung.cmd'
      include'pufloc.cmd'
      include'deffin.cmd'
      include'latlon.cmd'
      include 'pigdmp.cmd'

      data pi /3.1415926/
      nskdmp = 0
 
      if (ifgnow.eq.0) then
        ix = ig
        jy = jg
        kz = kg
      else
        ix = ifn
        jy = jfn
        kz = kfn
      endif
         
c     idump = 1 means puff is beyond edge of region, and is gone forever
c
c-----check for idump = 1 (determined in ttraj); all necessary varible 
c     modifications have already been done

      if (idump(npuff).eq.1) goto 900
c
c  dump all puffs    
c
c--- Emulate puffdmp routine with idump = 4 for all puffs
c
        nskdmp = nskins(npuff)
	nskins1(npuff)=nskins(npuff)
	tpuff1(npuff)=tpuff(npuff)
        if (tpuff1(npuff).lt.0.) then
          tpuff1(npuff) = curtim - abs(tpuff1(npuff))
        endif
c
      if (idiag .ne. 0) then
        write(*,2790) npuff
 2790   format('dumping puff # ',i3)
        write(nutrc,400) npuff,kpuff(npuff),nskdmp,ifgnow,ix,jy,kz
      endif
c
      iid=npuff
 
c-----fill dump arrays with puff location, volume, effective time and
c     effective emissions rate.
 
  160 continue
      igrid = ifgnow + 1
      idmp1(iid,igrid) = ix
      jdmp1(iid,igrid) = jy
      kdmp1(iid,igrid) = kz
      tdmp1(iid,igrid) = tpuff1(npuff)
      dtdmp1(iid) = dtpuf(npuff)
      dchk = amax1(dtpuf(npuff),delpuf)
      if (tdmp1(iid,igrid) .gt. 5.*dchk) then
        write(nutrc,2000) tdmp1(iid,igrid) , delpuf
        tdmp1(iid,igrid) = delpuf
      endif

      do 190 ns = 1,nskdmp
        if (ns.eq.1) voldmp1(iid) = 0.
        ib = nskins1(npuff)
        vdmp = pi*xlnpuf(npuff)*(sigma(npuff)*sigmav(npuff)/1.e6) *
     &         (rfacb(ib+1)**2 - rfacb(ib)**2)
        voldmp1(iid) = voldmp1(iid) + vdmp
        do 180 is = 1,nospec
          if (ns.eq.1) condmp1(is,iid) = 0.
          condmp1(is,iid) = condmp1(is,iid) + 
     &               (concs(is+1,ib,npuff)-connul(is+1,ib,npuff))
     &                 *vdmp*1.e9/dtpuf(npuff)
c
          if (idiag .ne. 0) then
            write(*,2001) iid, ib, is, voldmp1(iid),condmp1(is,iid),
     &                   concs(is+1,ib,npuff)
 2001       format('dmp #= ',i4,' skin= ',i4,' spec= ',i4,' vol= ',
     &             e11.4,' mass= ',e11.4,' conc= ',e11.4)
          endif

  180   continue
        nskins1(npuff) = nskins1(npuff) - 1
  190 continue
 
c-----load cell indices for parent grids (if any)

      if (ifgnow.gt.0) then
        inxgrd = ifgnow
  200   ifginr = inxgrd
        inxgrd = ifgptr(ifginr)

c-----coarse grid

        if (inxgrd.eq.0) then
          idmp1(iid,1) = ig 
          jdmp1(iid,1) = jg 
          kdmp1(iid,1) = kg
          tdmp1(iid,1) = tdmp1(iid,igrid)
          if (idiag.ne.0) write(nutrc,400) npuff,kpuff(npuff),nskdmp, 
     &                    inxgrd,idmp1(iid,1),jdmp1(iid,1),kdmp1(iid,1)
          goto 900

c-----fine grids

        else
          hrat = float(nhf(inxgrd))/float(nhf(ifgnow))
          idmp1(iid,inxgrd+1) = nhf(inxgrd)*(ixfb(ifgnow)-ixfb(inxgrd))
     &        + int((float(ifn)-1.5)*hrat) + 2
          jdmp1(iid,inxgrd+1) = nhf(inxgrd)*(jyfb(ifgnow)-jyfb(inxgrd))
     &        + int((float(jfn)-1.5)*hrat) + 2
          do 205 kkc1=1,nfz(inxgrd)
            if (kfn .le. kvmap(kkc1,ifginr)) then
              kdmp1(iid,inxgrd+1) = kkc1
              go to 210
            endif
  205     continue
  210     tdmp1(iid,inxgrd+1) = tdmp1(iid,igrid)
          if (idiag.ne.0) write(nutrc,400) npuff,kpuff(npuff),nskdmp, 
     &                      inxgrd,idmp1(iid,inxgrd+1),
     &                      jdmp1(iid,inxgrd+1),kdmp1(iid,inxgrd+1)
          goto 200
        endif
      endif

  900 return
  400 format(' puff # ',i6,' count ',i6,' is dumping ',i2,
     &       ' skins into grid ',i2,', cell ',3i5)
 2000 format(1x,'**** oink! ****** warning ***** oink! ***********',/,
     &       1x,'******** but i mean serious warning *************',/,
     &       1x,'   bad pig dump time :  ',f10.4,' resetting to delpuf :
     &   ',  f10.4)
      end
