      subroutine fmsflo(nxf,nyf,nzf,delfx,delfy,cncfa,
     &                  htfa,ufa,vfa,etafa,bcf,deltf,ifine)
c
c     *** (c) Copr. 1992  Systems Applications, Inc.  San Rafael, CA
c
c$Log: fmsflo.f,v $
c  Revision 1.3  1996/06/14  22:59:25  tcm
c   see comments below
c
c  Revision 1.2  1994/02/10  20:56:12  tcm
c  Cosmetic revisions to code by gem, syw, tcm
c
c
c
c   routine calculates mass flux across fine-grid region boundaries
c
c  A simple calculation of mass flux across region boundaries
c  (tcm, 6/11/91)
c
c     -- changed to deal with optional staggered u/v grids
c        (tcm, 7/15/91)
c     -- changed nlayer to nzf for calculation of flux through top
c        (gem, 3/14/96)
c
      include 'parm.cmd'
      include 'parchm.cmd'
      include 'parfin.cmd'
      include 'comuam.cmd'
      include 'balanc.cmd'
      include 'advec.cmd'
      dimension cncfa(nxf,nyf,nospec,nzf), htfa(nxf,nyf,nzf),
     &          ufa(nxf,nyf,nzf), vfa(nxf,nyf,nzf), etafa(nxf,nyf,nzf)
      dimension delfx(nyf)
      dimension bcf(mxfxy,4,mxspec,mxfz,maxfin)
c
c
c  total fluxes across lateral boundaries for all layers
c
      do 200 k=1,nzf
        do 150 j=2,nyf-1
c
c       calculate boundary inflow and outflow for west bnd
c
          i = 2
          if (k .eq. 1) then
            delh = 0.5*(htfa(i,j,k)+htfa(i-1,j,k))
          else
            delh = 0.5*(htfa(i,j,k)-htfa(i,j,k-1)
     &                 +htfa(i-1,j,k)-htfa(i-1,j,k-1))
          endif
          bfac = deltf*delfy*delh*1000.
          if (lstagr) then
            wb = ufa(i-1,j,k)
          else
            wb = .5*(ufa(i-1,j,k)+ufa(i,j,k))
          endif
          do 120 l=1,nospec
            if (wb .gt. 0.) then
              cc = bcf(j,4,l,k,ifine)
              fbcflo(l,1,4,ifine) = fbcflo(l,1,4,ifine) + 
     &               wb*cc*bfac
            else
              cc = cncfa(i,j,l,k)
              fbcflo(l,2,4,ifine) = fbcflo(l,2,4,ifine) - 
     &               wb*cc*bfac
            endif
  120     continue
c
c             calculate boundary inflow and outflow for east bnd
c
          i = nxf - 1
          if (k .eq. 1) then
            delh = 0.5*(htfa(i,j,k)+htfa(i+1,j,k))
          else
            delh = 0.5*(htfa(i,j,k)-htfa(i,j,k-1)
     &             +htfa(i+1,j,k)-htfa(i+1,j,k-1))
          endif
          bfac = deltf*delfy*delh*1000.
          if (lstagr) then
            wb = ufa(i,j,k)
          else
            wb = .5*(ufa(i,j,k)+ufa(i+1,j,k))
          endif
          do 140 l=1,nospec
            if (wb .lt. 0.) then
              cc = bcf(j,3,l,k,ifine)
              fbcflo(l,1,3,ifine) = fbcflo(l,1,3,ifine) - 
     &             wb*cc*bfac
            else
              cc = cncfa(i,j,l,k)
              fbcflo(l,2,3,ifine) = fbcflo(l,2,3,ifine) + 
     &             wb*cc*bfac
            endif
  140     continue
  150   continue
c
c             calculate boundary inflow and outflow for south bnd
c
        do 180 i=2,nxf-1
          j = 2
          if (k .eq. 1) then
            delh = 0.5*(htfa(i,j,k)+htfa(i,j-1,k))
          else
            delh = 0.5*(htfa(i,j,k)-htfa(i,j,k-1)
     &                 +htfa(i,j-1,k)-htfa(i,j-1,k-1))
          endif
          bfac = deltf*delfx(j)*delh*1000.
          if (lstagr) then
            wb = vfa(i,j-1,k)
          else
            wb = .5*(vfa(i,j,k)+vfa(i,j-1,k))
          endif
          do 160 l=1,nospec
            if (wb .gt. 0.) then
              cc = bcf(I,2,l,k,ifine)
              fbcflo(l,1,2,ifine) = fbcflo(l,1,2,ifine) + 
     &               wb*cc*bfac
            else
              cc = cncfa(i,j,l,k)
              fbcflo(l,2,2,ifine) = fbcflo(l,2,2,ifine) - 
     &               wb*cc*bfac
            endif
  160     continue
c
c       calculate boundary inflow and outflow for north bnd
c
          j = nyf - 1
          if (k .eq. 1) then
            delh = 0.5*(htfa(i,j,k)+htfa(i,j+1,k))
          else
            delh = 0.5*(htfa(i,j,k)-htfa(i,j,k-1)
     &                 +htfa(i,j+1,k)-htfa(i,j+1,k-1))
          endif
          bfac = deltf*delfx(j)*delh*1000.
          if (lstagr) then
            wb = vfa(i,j,k)
          else
            wb = .5*(vfa(i,j,k)+vfa(i,j+1,k))
          endif
          do 170 l=1,nospec
            if (wb .lt. 0.) then
              cc = bcf(I,1,l,k,ifine)
              fbcflo(l,1,1,ifine) = fbcflo(l,1,1,ifine) - 
     &                     wb*cc*bfac
            else
              cc = cncfa(i,j,l,k)
              fbcflo(l,2,1,ifine) = fbcflo(l,2,1,Ifine) + 
     &                     wb*cc*bfac
            endif
  170     continue
  180   continue
  200 continue
c
c  calculate flow through top
c
      vf1 = deltf*delfy*1000.
      do 300 j=2,nyf-1
        vf2 = vf1*delfx(j)
        do 290 i=2,nxf
          do 280 l=1,nospec
            vfac = -etafa(i,j,nzf)*vf2
            if (vfac .ge. 0.) then
              ftpflo(l,2,ifine) = ftpflo(l,2,ifine) 
     &                            + vfac*cncfa(i,j,l,nzf)
            else
              ftpflo(l,1,ifine) = ftpflo(l,1,ifine) - vfac*caloft(l)
            endif
  280     continue
  290   continue
  300 continue
c
      return
c
c  formats
c
 2000 format(//,1x,'Mass flux summary for ',f8.2,i8,':',/)
 2010 format(5x,'Species = ',a10,8x,'North')
 2020 format(25x,'In   ',1pe10.3,/,25x,'Out  ',e10.3,/,
     &       25x,'Net  ',e10.3,/)
 2030 format(12x,'West',17x,'Top',16x,'East',14x,'Surface emissions',
     &       3x,1pe10.3,/,5x,'In   ',e10.3,5x,'In   ',e10.3,5x,'In   ',
     &       e10.3,10x,'Elevated emissions  ',e10.3,/,
     &       5x,'Out  ',e10.3,5x,'Out  ',e10.3,5x,'Out  ',e10.3,10x,
     &       'Deposition',10x,e10.3,/,
     &       5x,'Net  ',e10.3,5x,'Net  ',e10.3,5x,'Net  ',e10.3,/,
     &       70x,'Total mass',10x,e10.3,/,33x,'South')
      end
