      subroutine gethaz(time,ndate,iunit,ieof)
c
c     *** (c) Copr. 1992  Systems Applications, Inc.  San Rafael, CA
c
c$Log: gethaz.f,v $
c  Revision 1.3  1998/11/04  01:40:24  tcm
c  Revised date treatment to handle calendar dates past 1999 and
c  to default Julian dates to 1951 to 2050.
c
c  Revision 1.2  94/02/10  20:56:33  tcm
c  Cosmetic revisions to code by gem, syw, tcm
c  
c
c
c
c  read a time interval off an ALBEDO-HAZE-OZONE COLUMN file
c  return parameters 
c  (tcm, 12/26/90)
c
      include 'parm.cmd'
      include 'parchm.cmd'
      include 'parfin.cmd'
      include 'comuam.cmd'
      include 'photrk.cmd'
      include 'oneday.cmd'
c
      character*10 mdum
      logical lroz, lrhz
c
c
      ieof = 0
c
c  find correct time and read data
c  convert all dates to julian
c
      if (ndate .gt. 99999) then
        call caltoj(ndate, nd1)
      else
        nd1 = ndate
      endif
c
   10 if (ihzdt1 .gt. 99999) then
        call caltoj(ihzdt1,id1)
        call caltoj(ihzdt2,id2)
      else
        id1 = ihzdt1
        id2 = ihzdt2
      endif
      if (iozdt1 .gt. 99999) then
        call caltoj(iozdt1,ido1)
        call caltoj(iozdt2,ido2)
      else
        ido1 = iozdt1
        ido2 = iozdt2
      endif
      if (l1day) then
        ndif = intrvl(id2,id1)
        id1 = nd1
        id2 = id1 + ndif
      endif
      ndays = intrvl(id1,nd1)
      tchk = hztim1 + 2400.*ndays
      ndays = intrvl(id2,nd1)
      tcend = hztim2 + 2400.*ndays
      if (time .ge. tchk-1. .and. time .le. tcend-1.) then
        lrhz = .false.
      else
        lrhz = .true.
      endif
      if (l1day) then
        ndif = intrvl(ido2,ido1)
        ido1 = nd1
        ido2 = ido1 + ndif
      endif
      ndays = intrvl(ido1,nd1)
      tchk = oztim1 + 2400.*ndays
      ndays = intrvl(ido2,nd1)
      tcend = oztim2 + 2400.*ndays
      if (time .ge. tchk-1. .and. time .le. tcend-1.) then
        lroz = .false.
      else
        lroz = .true.
      endif
      if (.not.lroz .and. .not.lrhz) return
c
   50 read (iunit,'(a10,i10,f10.0,i10,f10.0)',end=900) 
     &      mdum, idt1, tim1, idt2, tim2
      call lftpak(mdum)
      write(*,'(a,a10,a,i8,f10.2,a,i8,f10.2,a,i4)')
     &     ' Read ',mdum,' interval ',idt1, tim1, 
     &     ' to ', idt2, tim2,
     &     ' on unit ', iunit
      if (mdum(1:8) .eq. 'OZONECOL') then
        oztim1 = tim1
        iozdt1 = idt1
        oztim2 = tim2
        iozdt2 = idt2
        lroz = .false.
        do 100 j=noy,1,-1
          read(iunit,'(130i1)') (jozc(i,j),i=1,nox)
  100   continue
      else if (mdum(1:4) .eq. 'HAZE') then
        hztim1 = tim1
        ihzdt1 = idt1
        hztim2 = tim2
        ihzdt2 = idt2
        lrhz = .false.
        do 110 j=noy,1,-1
          read(iunit,'(130i1)') (jhaz(i,j),i=1,nox)
  110   continue
      else
        write(*,*) ' Unknown data label ', mdum
        stop
      endif
c
c
c  go back to check time and possibly read another interval
c
      go to 10
c
  900 ieof = 1
      return
c
      end
