      subroutine getqar(nxd,nyd,nsd,nx,ny,nsp,iunit,time,indate,
     $                  emtim1,iemdy1,emtim2,iemdy2,qa,ieof)
c
c     *** (c) Copr. 1992  Systems Applications, Inc.  San Rafael, CA
c
c$Log: getqar.f,v $
c  Revision 1.4  1998/11/10  17:49:43  ara
c  Included errlog.cmd file to introduce ierrlg variable
c  Directed error message to diag file and to log file (ierrlg)
c
c  Revision 1.3  1998/11/04  01:41:11  tcm
c  Revised date treatment to handle calendar dates past 1999 and
c  to default Julian dates to 1951 to 2050.
c
c  Revision 1.2  94/02/10  20:56:44  tcm
c  Cosmetic revisions to code by gem, syw, tcm
c  
c
c
c
c  read emissions for a specified time interval off a UAM type
c  emissions file and return parameters for main routine
c  (tcm, 11/1/90)
c
c  -- revised 10/11/91, tcm
c
      include 'oneday.cmd'
      include 'errlog.cmd'
      dimension qa(nxd,nyd,nsd)
      character*4 mdum(10)
c
      fact = 1./60.
      ieof = 0
      ndate = indate
c
c  find correct time and read emissions
c  (if ndate is calendar date, convert file date; but if ndate
c   is julian date, convert file date to julian)
c
      if (ndate .gt. 99999) then
        call caltoj(ndate,juldat)
        ndate = juldat
      endif
      if (iemdy1 .gt. 99999) then
        call caltoj(iemdy1,id1)
        call caltoj(iemdy2,id2)
      else
        id1 = iemdy1
        id2 = iemdy2
      endif
      ndays = intrvl(id1,ndate)
      tchk = emtim1*100. + 2400.*ndays
      ndays = intrvl(id2,ndate)
      tcend = emtim2*100. + 2400.*ndays
      if (time .ge. tchk-1. .and. time .le. tcend-1.) return
c
   30 read (iunit,end=900) iemdy1, emtim1, iemdy2, emtim2
      write(*,'(a,i8,f10.2,a,i8,f10.2,a,i4)')
     &     ' Read interval ',iemdy1, emtim1, ' to ', iemdy2, emtim2,
     &     ' on unit ', iunit
c
c
      do 200 l=1,nsp
        read(iunit,end=900) nseg,(mdum(i),i=1,10),
     &                      ((qa(i,j,l),i=1,nx),j=1,ny)
        do 50 j=1,ny
          do 40 i=1,nx
            qa(i,j,l)=qa(i,j,l)*fact
   40     continue
   50   continue
  200 continue
c
c  check time and if not correct, go back for another interval
c  (if ndate is calendar date, convert file date; but if ndate
c   is julian date, convert file date to julian)
c
      if (iemdy1 .gt. 99999) then
        call caltoj(iemdy1,id1)
        call caltoj(iemdy2,id2)
      else
        id1 = iemdy1
        id2 = iemdy2
      endif
      if (l1eday) then
        ndif = intrvl(id2,id1)
        id1 = ndate
        id2 = id1 + ndif
      endif
      iemdy1 = id1
      iemdy2 = id2
      ndays = intrvl(id1,ndate)
      tchk = emtim1*100. + 2400.*ndays
      ndays = intrvl(id2,ndate)
      tcend = emtim2*100. + 2400.*ndays
      if (time .ge. tcend) go to 30
      if (time .lt. tchk-1.) then
        write(*,*) ' Time error on EMISSIONS file',
     &             ' Current time: ',time, ndate,
     &             ' File time: ',emtim2,iemdy2
        write(8,*) ' Time error on EMISSIONS file',
     &             ' Current time: ',time,ndate,
     &             ' File time: ',emtim2,iemdy2
        write(ierrlg,*) 1068, '  Time error on EMISSIONS file',
     &             ' Current time: ',time,ndate,
     &             ' File time: ',emtim2,iemdy2
        stop
      endif
c
      return
c
  900 ieof = 1
      return
c
      end
