      subroutine heddv(nosp)
c
c     *** (c) Copr. 1992  Systems Applications, Inc.  San Rafael, CA
c
c$Log: heddv.f,v $
c  Revision 1.5  1998/11/20  22:21:23  tcm
c  Corrected spacing on end statement
c
c  Revision 1.4  1998/11/10  19:02:32  ara
c  Included errlog.cmd file to introduce ierrlg variable
c  Directed error message to diag file and to log file (ierrlg)
c
c  Revision 1.3  1998/11/04  01:42:38  tcm
c  Changed declarations to character variables where appropriate.
c
c  Revision 1.2  94/02/10  20:56:57  tcm
c  Cosmetic revisions to code by gem, syw, tcm
c  
c
c
c
c  reads header of deposition velocity file and
c  fills in species table for main routine
c  (tcm, 5/3/93)
c
      include 'parm.cmd'
      include 'parchm.cmd'
      include 'comchem.cmd'
      include 'idvcon.cmd'
      include 'errlog.cmd'
c
      character*4 memsp(10,mxxspc)
      character*10 m1, m2
c
      read(ibeta) ndvsp, ((memsp(m,l),m=1,10),l=1,ndvsp)
      IF (ndvsp .gt. mxxspc) then
        write(*,*) 'NUMBER OF SPECIES ON DEPOSITION VELOCITY FILE (',
     &             ndvsp,') IS GREATER THAN MAX ALLOWED (',mxxspc,').'
        write(8,*) 'NUMBER OF SPECIES ON DEPOSITION VELOCITY FILE (',
     &             ndvsp,') IS GREATER THAN MAX ALLOWED (',mxxspc,').'
        write(ierrlg,*) 1071,'  NUMBER OF SPECIES ON DEPOSITION ', 
     &             'VELOCITY FILE(',ndvsp,') IS GREATER THAN MAX ',
     &             'ALLOWED (',mxxspc,').'
        stop
      endif
c
c  find each species on file in standard species list
c  (0 will mean a species on file that is not needed.)
c  Treat FORM on file as equivalent to HCHO.
c  Treat HONO on file as equivalent to HNO2.
c
      do 100 l=1,ndvsp
        write(m1,'(10a1)') (memsp(i,l),i=1,10)
        do 80 lint=1,nosp
          write(m2,'(10a1)') (mspec(i,lint),i=1,10)
          if (m1 .eq. m2) then
            kdvsp(l) = lint
            write(*,'(a,i3,1x,a,a,i3,1x,a,a)') ' Species ',l,m1,
     &            ' on deposition velocity file = species ',
     &            lint,m2,' internally.'
            go to 100
          endif
          if (m1 .eq. 'FORM      ') then
            if ('HCHO      ' .eq. m2) then
              kdvsp(l) = lint
              write(*,'(a,i3,1x,a,a,i3,1x,a,a)') ' Species ',l,m1,
     &            ' on deposition velocity file = species ',
     &            lint,m2,' internally.'
              go to 100
            endif
          endif
          if (m1 .eq. 'HONO      ') then
            if ('HNO2      ' .eq. m2) then
              kdvsp(l) = lint
              write(*,'(a,i3,1x,a,a,i3,1x,a,a)') ' Species ',l,m1,
     &            ' on deposition velocity file = species ',
     &            lint,m2,' internally.'
              go to 100
            endif
          endif
   80   continue
        kdvsp(l) = 0
  100 continue
c
      return
      end
