      subroutine hedqar(nosp, nxsz, nysz, iunit, nsem, kespc)
c
c     *** (c) Copr. 1992  Systems Applications, Inc.  San Rafael, CA
c
c$Log: hedqar.f,v $
c  Revision 1.5  1998/11/20  22:14:52  tcm
c  Deleted extraneous : on line 55
c
c  Revision 1.4  1998/11/10  20:13:14  ara
c  Included errlog.cmd file to introduce ierrlg variable
c  Directed error messages to diag file and to log file (ierrlg)
c
c  Revision 1.3  1998/11/04  01:43:57  tcm
c  Changed declarations to character variables where appropriate.
c
c  Revision 1.2  94/02/10  20:57:10  tcm
c  Cosmetic revisions to code by gem, syw, tcm
c  
c
c
c
c  reads header of UAM area source emissions file and
c  fills in parameters for main routine
c  (tcm, 11/1/90)
c
      include 'parm.cmd'
      include 'parchm.cmd'
      include 'comchem.cmd'
      include 'errlog.cmd'
      dimension kespc(mxemit)
c
      character*4 memsp(10,mxemit), note(60), ifile(10) 
      character*10 m1, m2
c
      read(iunit) (ifile(i),i=1,10), (note(i),i=1,60), 
     &            nseg, nemspc, idate, begtim, 
     &            jdate, endtim
      write(m1,'(10a1)') ifile
      if (m1 .ne. 'EMISSIONS ') then
        write(*,'(a,i2,a,a,/,a)') ' File on unit ',iunit,' is ',m1,
     &           ' It should be EMISSIONS.'
        write(8,'(a,i2,a,a,/,a)') ' File on unit ',iunit,' is ',m1,
     &           ' It should be EMISSIONS.'
        write(ierrlg,'(i4,1x,a,i2,a,a,/,a)') 1078,' File on unit',
     &           iunit,' is ',m1,'It should be EMISSIONS.'

        stop
      endif
      if (nemspc .gt. mxemit) then
        write(*,*) 'NUMBER OF SPECIES ON INPUT FILE (',nemspc,')',
     &             ' IS GREATER THAN MAX ALLOWED (',mxemit,').'
        write(8,*) 'NUMBER OF SPECIES ON INPUT FILE (',nemspc,')',
     &             ' IS GREATER THAN MAX ALLOWED (',mxemit,').'
        write(ierrlg,*) 1079, '  NUMBER OF SPECIES ON INPUT FILE (',
     &             nemspc,') IS GREATER THAN MAX ALLOWED (',mxemit,').' 
        stop
      endif
      read  (iunit) orgx, orgy, izone, utmx, utmy, deltax, deltay,
     &          nx, ny, nz, nzlowr, nzuppr, htsur, htlow, htupp
      if (nx .ne. nxsz) then
        write(*,*) 'NUMBER OF X CELLS ON INPUT FILE (',nx,')',
     &             ' IS INCORRECT. (',nxsz,').'
        write(8,*) 'NUMBER OF X CELLS ON INPUT FILE (',nx,')', 
     &             ' IS INCORRECT. (',nxsz,').'
        write(ierrlg,*) 1080,'  NUMBER OF X CELLS ON INPUT FILE (',
     &             nx,') IS INCORRECT. (',nxsz,').'
        stop
      endif
      if (ny .ne. nysz) then
        write(*,*) 'NUMBER OF Y CELLS ON INPUT FILE (',ny,')',
     &             ' IS INCORRECT. (',nysz,').'
        write(8,*) 'NUMBER OF Y CELLS ON INPUT FILE (',ny,')',
     &              ' IS INCORRECT. (',nysz,').'
        write(ierrlg,*) 1081,'  NUMBER OF Y CELLS ON INPUT FILE (',
     &             ny,') IS INCORRECT. (',nysz,').'
        stop
      endif
      read(iunit) nxx,nyy,nxcell,nycell
      read(iunit) ((memsp(m,l),m=1,10),l=1,nemspc)
c
c  find each species on emissions file in standard species list
c  (0 will mean a species on emissions file that is not needed.)
c  Treat FORM on EMISSIONS file as equivalent to HCHO.
c  Treat HONO on EMISSIONS file as equivalent to HNO2.
c
      do 100 l=1,nemspc
        write(m1,'(10a1)') (memsp(i,l),i=1,10)
        do 80 lint=1,nosp
          write(m2,'(10a1)') (mspec(i,lint),i=1,10)
          if (m1 .eq. m2) then
            kespc(l) = lint
            write(*,'(a,i3,1x,a,a,i3,1x,a,a)') ' Species ',l,m1,
     &            ' on EMISSIONS file = species ',lint,m2,' internally.'
            go to 100
          endif
          if (m1 .eq. 'FORM      ') then
            if ('HCHO      ' .eq. m2) then
              kespc(l) = lint
              write(*,'(a,i3,1x,a,a,i3,1x,a,a)') ' Species ',l,m1,
     &            ' on EMISSIONS file = species ',lint,m2,' internally.'
              go to 100
            endif
          endif
          if (m1 .eq. 'HONO      ') then
            if ('HNO2      ' .eq. m2) then
              kespc(l) = lint
              write(*,'(a,i3,1x,a,a,i3,1x,a,a)') ' Species ',l,m1,
     &            ' on EMISSIONS file = species ',lint,m2,' internally.'
              go to 100
            endif
          endif
   80   continue
        kespc(l) = 0
  100 continue
c
      nsem = nemspc
      return
      end
