      integer function intrvl(idate1, idate2)
c
c  intrvl calculates the number of days between idate1 and idate2
c  that is, idate1 minus idate2
c  date format is julian of the for yyddd
c  two digit years 51 - 99 are 1951 to 1999, 
c  two digit years 00 - 50 are 2000 to 2050
c
c
c  if dates are equal just return zero
c
      if (idate1 .eq. idate2) then
        intrvl = 0
        return
c
c  if years are equal, return difference in days
c
      else if (idate1/1000 .eq. idate2/1000) then
        intrvl = idate1 - idate2
        return
c
c  if years are not equal, then separate year and days
c  and calculate interval
c
      else
        iyr1 = idate1/1000
        if (iyr1 .lt. 51) iyr1 = iyr1 + 100
        iday1 = mod(idate1,1000)
        iyr2 = idate2/1000
        if (iyr2 .lt. 51) iyr2 = iyr2 + 100
        iday2 = mod(idate2,1000)
        nd1 = 365*iyr1 + iday1 + iyr1/4
        if (mod(iyr1,4) .eq. 0) nd1 = nd1 - 1
        nd2 = 365*iyr2 + iday2 + iyr2/4
        if (mod(iyr2,4) .eq. 0) nd2 = nd2 - 1
        intrvl = nd1 - nd2
        return
      endif
      end
