        subroutine irr_init1(nx,ny,nz)
c
c  subroutine to read in output levels and locations
c
c$Log: irr_init1.f,v $
c  Revision 1.2  2002/06/26  20:44:13  tcm
c  Eliminated some dead code.
c
c  Revision 1.1  1999/07/07  00:49:55  tcm
c  Initial revision
c
c
c  modified 7/2/96 (tcm) - 
c
c       separated initialization of iflagf from iflag so
c       that proper i,j loop range can be used.
c
       include 'parm.cmd'
       include 'parfin.cmd'
       include 'parchm.cmd'
       include 'deffin.cmd'
       include 'irmb.cmd'
c
       logical lcorner
c
       character*60 chem_info, info1, info2
       integer seq_layerf(maxfin)
c
c  start setting flags for cell-tracking
c
       nxy = nx * ny
       irr_cnt = 0
       irr_coarse = 0
       irr_fine = 0
c
       do j = 1, ny
       do i = 1, nx
          iflag(i,j) = -9
       enddo
       enddo

*      do if = 1, ifine !this is just plain wrong. hpd, 11.14.96
       do if = 1, numfin
*hpd start
          irr_layerf(if)=0
          seq_layerf(if)=0
          do k=1,mxfz
            irr_ipvf(if,k)=0
          enddo
*hpd end
          do j=1,mxfy
          do i=1,mxfx
             iflagf(i,j,if) = -9
          enddo
          enddo
       enddo
c
       if (irrin .le. 0) return
c
c  control flag to output hourly data (t) or every advection step data (f)
c
       read (irrin,'(a)') info1
       read (irrin,*) lhrout
       if (lhrout) then
          write (*,1110)
       else
          write (*,1120)
       endif
c
c  read in the coarse grid vertical levels to print out (pointer matrix used)
c
       read (irrin,'(a)') info1
       read (irrin,*) irr_layer
       if (irr_layer .gt. mxfz) then
         write(*,*) '*********ERROR*********'
         write(*,*) 'Too many layers specified in irr control file.'
         write(*,*) 'User specified ',irr_layer
         write(*,*) 'Max is ', mxfz
         stop
       endif
       do i = 1, irr_layer
          read (irrin,*) irr_ipv(i)
*hpd, 9.23.96 vertical nesting for upper layers not done yet, so restrict
*             user input to layer 1 only. Note that btflux is wrong for 
*             upper layers anyhow in this code.
*
* hpd, 11.14.96: implemented vertical nesting, therefor commented out below
*         IF(numfin.gt.0.and.irr_ipv(i).ne.1) THEN
*           WRITE(*,*) 'vertical nesting of irr output not supported.'
*           WRITE(*,*) 'only layer one allowed...'
*           STOP 121
*         ENDIF
          irr_cnt   = irr_cnt + 1
       enddo
       if (irr_layer .ne. irr_cnt) goto 888
c
c  read in the grid cells to print out (pointer matrix used)
c
       read (irrin,'(a)') info2
       write (*,'(a)') info2
c
c  if sw-ne corners are specified, then lcorner = .true.,
c  otherwise read in each grid cell .....
c
       read (irrin,*) lcorner
       if (lcorner) then
          irr_cnt = 0
          irr_cntf = 0
          read(irrin,*) ncorner     !added 9.19.96, hpd, for multiple block entry
        DO m=1,ncorner
          read (irrin,*) i_sw, j_sw 
          read (irrin,*) i_ne, j_ne
c
          iswm1 = i_sw - 1
          inep1 = i_ne + 1
          jswm1 = j_sw - 1
          jnep1 = j_ne + 1
c
c  do the coarse grids cells
c 
          do j = j_sw, j_ne
             do i = i_sw, i_ne
                irr_cnt   = irr_cnt + 1
                if (irr_cnt .gt. irrxy) then
                  write(*,*) '*********ERROR*********'
                  write(*,*) 
     &       'Too many coarse grid cells specified for irr tracking.'
                  write(*,*) 'Max is ', irrxy
                  stop
                endif
                irr_grds  = irr_cnt
                irr_f(irr_cnt) = 0
                irr_x(irr_cnt) = i
                irr_y(irr_cnt) = j
                iflag(i,j) = irr_cnt
             enddo
          enddo
        ENDDO
c
c  the total number of cells in coarse grid per layer
c
          irr_coarse = irr_cnt 
          irr_cnt = 0
c
c  do the fine grids
c
         do if = 1, numfin ! loop through all the fine levels
c                          ! and find the horizontal fine cells in coarse cells
* hpd, 9.23.96
           DO i=1,irr_coarse
             IF(irr_x(i).ge.ixfb(if).and.irr_x(i).le.ixfe(if).and.
     &         irr_y(i).ge.jyfb(if).and.irr_y(i).le.jyfe(if)) THEN
               DO jc=1,nhf(if)
                 DO ic=1,nhf(if)
                   irr_cnt=irr_cnt + 1
                   if (irr_cnt .gt. irrxyf) then
                     write(*,*) '*********ERROR*********'
                     write(*,*) 
     &      'Too many fine grid cells specified for irr tracking.'
                     write(*,*) 'Max is ', irrxyf
                     stop
                   endif
                   irr_ff(irr_cnt)=if
                   irr_xf(irr_cnt)=(irr_x(i)-ixfb(if))*nhf(if)+1+ic
                   irr_yf(irr_cnt)=(irr_y(i)-jyfb(if))*nhf(if)+1+jc
                   iflagf(irr_xf(irr_cnt),irr_yf(irr_cnt),if)=irr_cnt
                 ENDDO
               ENDDO
             ENDIF
           ENDDO 
         ENDDO
         irr_fine=irr_cnt
*
* hpd, 9.23.96: this code doesn't work, therefor fixed as shown above
*
*            do j = 2, nfy(if)-1
*               jc = jyfb(if) + (j-2)/nhf(if)
*               do i = 2, nfx(if)-1
*                  ic = ixfb(if) + (i-2)/nhf(if)
*                  if (ic.gt.iswm1 .and. ic.lt.inep1 .and.
*    &                 jc.gt.jswm1 .and. jc.lt.jnep1) then
*                      irr_cnt          = irr_cnt + 1
*                      if (irr_cnt .gt. irrxyf) then
*                        write(*,*) '*********ERROR*********'
*                        write(*,*) 
*    &       'Too many fine grid cells specified for irr tracking.'
*                        write(*,*) 'Max is ', irrxyf
*                        stop
*                      endif
*                      irr_ff(irr_cnt)   = if
*                      irr_xf(irr_cnt)  = i
*                      irr_yf(irr_cnt)  = j
*                      iflagf(i,j,if) = irr_cnt
*                  endif
*               enddo
*            enddo
*         enddo
*         irr_fine = irr_cnt
c
c  for the cells that are specified explicitly
c
       else
c
          read (irrin,*) irr_grds
          if (irr_grds .gt. irrxy) then
            write(*,*) '*********ERROR*********'
            write(*,*) 
     &       'Too many coarse grid cells specified for irr tracking.'
            write(*,*) 'Max is ', irrxy
            stop
          endif
          irr_cnt = 0
          do i = 1, irr_grds
             irr_cnt   = irr_cnt + 1
             irr_f(irr_cnt) = 0
             read (irrin,*)irr_x(i), irr_y(i)
             iflag(irr_x(i),irr_y(i)) = irr_cnt  ! for coarse grid cell
          enddo
c
c  the total number of coarse grid cells
c
          irr_coarse = irr_cnt
          irr_cnt = 0
c
c   now for the fine grid cells
c
* ibid from above comments, hpd, 9.23.95
        DO if=1,numfin
           DO i=1,irr_coarse
             IF(irr_x(i).ge.ixfb(if).and.irr_x(i).le.ixfe(if).and.
     &         irr_y(i).ge.jyfb(if).and.irr_y(i).le.jyfe(if)) THEN
               DO jc=1,nhf(if)
                 DO ic=1,nhf(if)
                   irr_cnt=irr_cnt + 1
                   if (irr_cnt .gt. irrxyf) then
                     write(*,*) '*********ERROR*********'
                     write(*,*) 
     &      'Too many fine grid cells specified for irr tracking.'
                     write(*,*) 'Max is ', irrxyf
                     stop
                   endif
                   irr_ff(irr_cnt)=if
                   irr_xf(irr_cnt)=(irr_x(i)-ixfb(if))*nhf(if)+1+ic
                   irr_yf(irr_cnt)=(irr_y(i)-jyfb(if))*nhf(if)+1+jc
                   iflagf(irr_xf(irr_cnt),irr_yf(irr_cnt),if)=irr_cnt
                 ENDDO
               ENDDO
             ENDIF
           ENDDO 
         ENDDO
         irr_fine=irr_cnt
*
*         do ig = 1, irr_grds   !shouldn't this be irr_coarse? hpd
c
*            irx = irr_x(ig)
*            iry = irr_y(ig)
c
c  if the coarse grid cell falls within the area with nested grid, we need
c  to figure out how many grid cells are inside
c
*            do if = 1, numfin
*               do j = 2, nfy(if)-1
*                  jc = jyfb(if) + (j-2)/nhf(if)
*                  do i = 2, nfx(if)-1
*                     ic = ixfb(if) + (i-2)/nhf(if)
*                     if (ic.eq.irx .and. jc.eq.iry) then
*                        irr_cnt          = irr_cnt + 1
*                        if (irr_cnt .gt. irrxyf) then
*                          write(*,*) '*********ERROR*********'
*                          write(*,*) 
*    &       'Too many fine grid cells specified for irr tracking.'
*                          write(*,*) 'Max is ', irrxyf
*                          stop
*                        endif
*                        irr_ff(irr_cnt)   = if
*                        irr_xf(irr_cnt)  = i
*                        irr_yf(irr_cnt)  = j
*                        iflagf(i,j,if) = irr_cnt
*                     endif
*                  enddo
*               enddo
*            enddo
*         enddo
*         irr_fine = irr_cnt
       endif

* hpd, 11.14.96 : set vertical nesting indices
*
* irr_layerf(fine grid index)=number of layers to save in this fine grid
* irr_ipvf(fine grid index,1..num layers to save)=index of layers to save
*
       DO i=1,irr_fine               !overkill, but will certainly get them all
         if(irr_layerf(irr_ff(i)).eq.0) THEN        !haven't done this grid yet
           do k=1,irr_layer
             if(irr_ipv(k).eq.1) then
               ia = 1
               ib = kvmap(irr_ipv(k),irr_ff(i))
             else
               ia = kvmap(irr_ipv(k)-1,irr_ff(i))+1
               ib = kvmap(irr_ipv(k),irr_ff(i))
             endif
             do kk=ia,ib
                irr_layerf(irr_ff(i))=irr_layerf(irr_ff(i))+1
                irr_ipvf(irr_ff(i),irr_layerf(irr_ff(i)))=kk
             enddo
           enddo
         endif
       ENDDO


c
c   write to log file
c
       write (*, 1000) nx, ny, nxy, irr_coarse, irr_fine
c
c  write out coarse grid cell definition
c
       write (*,1010)
       do i = 1, irr_coarse
          write (*,1030) i, irr_x(i), irr_y(i), irr_f(i),
     &                   iflag(irr_x(i),irr_y(i))
       enddo
C
c  now write out fine grid cell definition
c
       write (*,1020)
       do i = 1, irr_fine
          write (*,1030) i, irr_xf(i), irr_yf(i), irr_ff(i),
     &                   iflagf(irr_xf(i),irr_yf(i),irr_ff(i))
       enddo
c
C   write out vertical layers and horizontal grids in the model domain
C   and the number of irr grid cells tallied in the model domain.
C
* hpd, 11.14.96
       write(*,*) 'vertical layers to be saved: '
       write(*,*) 'grid      layers'
       write(*,1200) 0,(irr_ipv(i),i=1,irr_layer)
       nests=0
       do j=1,maxfin
         if(irr_layerf(j).ne.0) THEN
           write(*,1200) j,(irr_ipvf(j,i),i=1,irr_layerf(j))
           nests=nests+1
           seq_layerf(nests)=irr_layerf(j) !sequential list
         endif
       enddo
 1200 FORMAT(i5,5x,20i5)
*
       write (3) nx, ny, nz
       write (3) 1, irr_layer, irr_coarse, irr_fine
c
       write (4) nx, ny, nz
       write (4) nests,(seq_layerf(i),i=1,nests),irr_coarse,irr_fine
C
       goto 9999
C
888    continue
       write (*,1050) irr_layer, irr_cnt
       stop ' error in irr_init1'
c889    continue
c       write (*,1060) irr_grds, irr_cnt
c       stop ' error in irr_init1'
C
1000   format (//,1X,' Number of dimensions in this simulation is:',
     &             /,'    NX = ',I5,
     &             /,'    NY = ',I5,/,
     &             /,' Total grid cells in each level = ',i7,
     &             /,'    # of coarse cells to output = ',i7,
     &             /,'    # of fine   cells to output = ',i7,/)
1010   format (/,' IPRAM coarse grid cell definition:')
1020   format (/,' IPRAM fine grid cell definition:')
1030   format (5(5x,i5))
1050   format (//,' *** ERROR ***'
     &          /,' The number of vertical layers to be printed  :',i7,
     &          /,' does not agree with total locations provided :',i7)
1060   format (//,' *** ERROR ***'
     &          /,' The number of grid cells to be printed       :',i7,
     &          /,' does not agree with total locations provided :',i7)
1110   format (//,' IPRAM will be printed along with other',
     &            ' standard UAM-V outputs')
1120   format (//,' IPRAM will be printed at every coarse grid cell',
     &            ' time step')
C
9999   return
       end
