      subroutine masflo(time,ndate,deltat,lprint)
c
c     *** (c) Copr. 1992  Systems Applications, Inc.  San Rafael, CA
c
c$Log: masflo.f,v $
c  Revision 1.2  1994/02/10  20:58:19  tcm
c  Cosmetic revisions to code by gem, syw, tcm
c
c
c
c
c  a simple calculation of mass flux across region boundaries
c  (tcm, 6/11/91)
c
c     -- changed to deal with optional staggered u/v grids
c        (tcm, 7/15/91)
c
      include 'parm.cmd'
      include 'parchm.cmd'
      include 'parfin.cmd'
      include 'comuam.cmd'
      include 'balanc.cmd'
      include 'advec.cmd'
      logical lprint
c
c  if we have reached an output time, print the mass fluxes and
c  reset them to zero.
c
      if (lprint) then
c
c  add this interval's fluxes into cumulative arrays
c
        do 350 l=1,nospec
          eflcu(l) = eflcu(l) + eflow(l)
          ptflcu(l) = ptflcu(l) + ptflow(l)
          dpflcu(l) = dpflcu(l) + dpflow(l)
          pgflcu(l) = pgflcu(l) + pgflow(l)
          gpflcu(l) = gpflcu(l) + gpflow(l)
          pgemcu(l) = pgemcu(l) + pgemfl(l)
          pxflcu(l) = pxflcu(l) + pxflow(l)
          do 340 n=1,2
            tpflcu(l,n) = tpflcu(l,n) + tpflow(l,n)
            do 330 k=1,4
              bcflcu(l,n,k) = bcflcu(l,n,k) + bcflow(l,n,k)
  330       continue
  340     continue
  350   continue
c
c  print mass flux summary (only for species to appear on average file)
c
        write(8,2000) time, ndate
        do 400 l=1,navspc,2
          linspc = kavspc(l)
          if (l .lt. navspc) lins2 = kavspc(l+1)
          if (l .eq. navspc) then
            write(8,2010) mavspc(l)
            fnet = bcflow(linspc,1,1) - bcflow(linspc,2,1)
            write(8,2020) bcflow(linspc,1,1), eflow(linspc),
     &                    bcflow(linspc,2,1), ptflow(linspc),
     &                    fnet, dpflow(linspc)
            fnetw = bcflow(linspc,1,4) - bcflow(linspc,2,4)
            fnett = tpflow(linspc,1) - tpflow(linspc,2)
            fnete = bcflow(linspc,1,3) - bcflow(linspc,2,3)
            write(8,2030) bcflow(linspc,1,4), 
     &                  tpflow(linspc,1), bcflow(linspc,1,3),
     &                  gpflow(linspc), bcflow(linspc,2,4),
     &                  tpflow(linspc,2), bcflow(linspc,2,3),
     &                  pgflow(linspc), fnetw, fnett, fnete,
     &                  pgemfl(linspc), pxflow(linspc)
            fnet = bcflow(linspc,1,2) - bcflow(linspc,2,2)
            write(8,2035) bcflow(linspc,1,2), bcflow(linspc,2,2), 
     &                    tmas(linspc), fnet
          else
            write(8,2110) mavspc(l), mavspc(l+1)
            fnet = bcflow(linspc,1,1) - bcflow(linspc,2,1)
            fnet2 = bcflow(lins2,1,1) - bcflow(lins2,2,1)
            write(8,2120) bcflow(linspc,1,1), eflow(linspc), 
     &            bcflow(lins2,1,1), eflow(lins2),
     &            bcflow(linspc,2,1), ptflow(linspc),
     &            bcflow(lins2,2,1), ptflow(lins2),
     &            fnet, dpflow(linspc), fnet2, dpflow(lins2)
            fnetw = bcflow(linspc,1,4) - bcflow(linspc,2,4)
            fnett = tpflow(linspc,1) - tpflow(linspc,2)
            fnete = bcflow(linspc,1,3) - bcflow(linspc,2,3)
            fnetw2 = bcflow(lins2,1,4) - bcflow(lins2,2,4)
            fnett2 = tpflow(lins2,1) - tpflow(lins2,2)
            fnete2 = bcflow(lins2,1,3) - bcflow(lins2,2,3)
            write(8,2130) bcflow(linspc,1,4), 
     &                  tpflow(linspc,1), bcflow(linspc,1,3),
     &                  gpflow(linspc), 
     &                  bcflow(lins2,1,4), 
     &                  tpflow(lins2,1), bcflow(lins2,1,3),
     &                  gpflow(lins2),
     &                  bcflow(linspc,2,4),
     &                  tpflow(linspc,2), bcflow(linspc,2,3),
     &                  pgflow(linspc),
     &                  bcflow(lins2,2,4),
     &                  tpflow(lins2,2), bcflow(lins2,2,3),
     &                  pgflow(lins2),
     &                  fnetw, fnett, fnete, pgemfl(linspc),
     &                  fnetw2, fnett2, fnete2, pgemfl(lins2),
     &                  pxflow(linspc), pxflow(lins2)
            fnet = bcflow(linspc,1,2) - bcflow(linspc,2,2)
            fnet2 = bcflow(lins2,1,2) - bcflow(lins2,2,2)
            write(8,2135) bcflow(linspc,1,2), bcflow(lins2,1,2),
     &            bcflow(linspc,2,2), tmas(linspc), bcflow(lins2,2,2), 
     &            tmas(lins2), fnet, fnet2
          endif
          write(8,2040)
  400   continue
c
c  zero out flux arrays for next interval
c
        do 430 l=1,nospec
          eflow(l) = 0.
          ptflow(l) = 0.
          dpflow(l) = 0.
          gpflow(l) = 0.
          pgflow(l) = 0.
          pgemfl(l) = 0.
          pxflow(l) = 0.
          do 420 n=1,2
            tpflow(l,n) = 0.
            do 410 k=1,4
              bcflow(l,n,k) = 0.
  410       continue
  420     continue
  430   continue
      endif
c
c  total fluxes across lateral boundaries for all layers
c
      do 200 k=1,nlayer
        do 150 j=1,noy
c
c       calculate boundary inflow and outflow for west bnd
c
          if (istr(j) .gt. nox) go to 150
          i = istr(j) + 1
          if (k .eq. 1) then
            delh = 0.5*(h(i,j,k)+h(i-1,j,k))
          else
            delh = 0.5*(h(i,j,k)-h(i,j,k-1)+h(i-1,j,k)-h(i-1,j,k-1))
          endif
          bfac = deltat*deltay*delh*1000.
          if (lstagr) then
            wb = u(i-1,j,k)
          else
            wb = .5*(u(i-1,j,k)+u(i,j,k))
          endif
          do 120 l=1,nospec
            if (wb .gt. 0.) then
              cc = bc(j,4,l,k)
              bcflow(l,1,4) = bcflow(l,1,4) + 
     &                  wb*cc*bfac
            else
              cc = conc(i,j,l,k)
              bcflow(l,2,4) = bcflow(l,2,4) - 
     &                  wb*cc*bfac
            endif
  120     continue
c
c             calculate boundary inflow and outflow for east bnd
c
          i = iend(j) - 1
          if (k .eq. 1) then
            delh = 0.5*(h(i,j,k)+h(i+1,j,k))
          else
             delh = 0.5*(h(i,j,k)-h(i,j,k-1)+h(i+1,j,k)-h(i+1,j,k-1))
          endif
          bfac = deltat*deltay*delh*1000.
          if (lstagr) then
            wb = u(i,j,k)
          else
            wb = .5*(u(i,j,k)+u(i+1,j,k))
          endif
          do 140 l=1,nospec
            if (wb .lt. 0.) then
              cc = bc(j,3,l,k)
              bcflow(l,1,3) = bcflow(l,1,3) - 
     &                wb*cc*bfac
            else
              cc = conc(i,j,l,k)
              bcflow(l,2,3) = bcflow(l,2,3) + 
     &                wb*cc*bfac
            endif
  140     continue
  150   continue
c
c             calculate boundary inflow and outflow for south bnd
c
        do 180 i=1,nox
          if (jstr(i) .gt. noy) go to 180
          j = jstr(i) + 1
          if (k .eq. 1) then
            delh = 0.5*(h(i,j,k)+h(i,j-1,k))
          else
            delh = 0.5*(h(i,j,k)-h(i,j,k-1)+h(i,j-1,k)-h(i,j-1,k-1))
          endif
          bfac = deltat*deltax(j)*delh*1000.
          if (lstagr) then
            wb = v(i,j-1,k)
          else
            wb = .5*(v(i,j,k)+v(i,j-1,k))
          endif
          do 160 l=1,nospec
            if (wb .gt. 0.) then
              cc = bc(i,2,l,k)
              bcflow(l,1,2) = bcflow(l,1,2) + 
     &                 wb*cc*bfac
            else
              cc = conc(i,j,l,k)
              bcflow(l,2,2) = bcflow(l,2,2) - 
     &                 wb*cc*bfac
            endif
  160     continue
c
c       calculate boundary inflow and outflow for north bnd
c
          j = jend(i) - 1
          if (k .eq. 1) then
            delh = 0.5*(h(i,j,k)+h(i,j+1,k))
          else
            delh = 0.5*(h(i,j,k)-h(i,j,k-1)+h(i,j+1,k)-h(i,j+1,k-1))
          endif
          bfac = deltat*deltax(j)*delh*1000.
          if (lstagr) then
            wb = v(i,j,k)
          else
            wb = .5*(v(i,j,k)+v(i,j+1,k))
          endif
          do 170 l=1,nospec
            if (wb .lt. 0.) then
              cc = bc(i,1,l,k)
              bcflow(l,1,1) = bcflow(l,1,1) - 
     &                      wb*cc*bfac
            else
              cc = conc(i,j,l,k)
              bcflow(l,2,1) = bcflow(l,2,1) + 
     &                      wb*cc*bfac
            endif
  170     continue
  180   continue
  200 continue
c
c  calculate flow through top
c
      vf1 = deltat*deltay*1000.
      do 300 j=1,noy
        if (istr(j) .gt. nox) go to 300
        vf2 = vf1*deltax(j)
        do 290 i=istr(j),iend(j)
          do 280 l=1,nospec
            vfac = -eta(i,j,nlayer)*vf2
            if (vfac .ge. 0.) then
              tpflow(l,2) = tpflow(l,2) + vfac*conc(i,j,l,nlayer)
            else
              tpflow(l,1) = tpflow(l,1) - vfac * caloft(l)
            endif
  280     continue
  290   continue
  300 continue
c
      return
c
c  formats
c
 2000 format(//,1x,'mass flux summary in moles for coarse grid at',
     &       f8.2,i8,':',/)
 2010 format(1x,'spec = ',a10,2x,'north')
 2020 format(13x,'in  ',1pe10.3,15x,'srf emiss ',e10.3,/,
     &       13x,'out ',e10.3,15x,'elv emiss ',e10.3,/,
     &       13x,'net ',e10.3,15x,'depostn   ',e10.3,/)
 2030 format(8x,'west',8x,'top',8x,'east',6x,'pig mass: ',
     &       /,1x,'in  ',1pe10.3,2x,e10.3,2x,
     &       e10.3,3x,'grid out  ',e10.3,/,
     &       1x,'out ',e10.3,2x,e10.3,2x,e10.3,3x,
     &       'plume in  ',e10.3,/,
     &       1x,'net ',e10.3,2x,e10.3,2x,e10.3,3x,'plume ems ',e10.3,
     &       /,42x,'exited    ',e10.3,/,20x,'south')
 2035 format(13x,'in  ',1pe10.3,/,
     &       13x,'out ',e10.3,15x,'tot mass  ',e10.3,/,
     &       13x,'net ',e10.3,e10.3,/)
 2040 format(1x,126(1h-))
 2110 format(1x,'spec = ',a10,2x,'north',38x,'| ','spec = ',
     &       a10,2x,'north')
 2120 format(13x,'in  ',1pe10.3,15x,'srf emiss ',e10.3,1x,'|',
     &       13x,'in  ',e10.3,15x,'srf emiss ',e10.3,/,
     &       13x,'out ',e10.3,15x,'elv emiss ',e10.3,1x,'|',
     &       13x,'out ',e10.3,15x,'elv emiss ',e10.3,/,
     &       13x,'net ',e10.3,15x,'depostn   ',e10.3,1x,'|',
     &       13x,'net ',e10.3,15x,'depostn   ',e10.3,/,63x,'|')
 2130 format(8x,'west',8x,'top',8x,'east',6x,'pig mass: ',
     &       12x,'|',8x,'west',8x,'top',8x,'east',6x,
     &       'pig mass: ',/,1x,'in  ',1pe10.3,2x,e10.3,2x,
     &       e10.3,3x,'grid out  ',e10.3,1x,'|',
     &       1x,'in  ',e10.3,2x,e10.3,2x,
     &       e10.3,3x,'grid out  ',e10.3,/,
     &       1x,'out ',e10.3,2x,e10.3,2x,e10.3,3x,
     &       'plume in  ',e10.3,1x,'|',
     &       1x,'out ',e10.3,2x,e10.3,2x,e10.3,3x,
     &       'plume in  ',e10.3,/,
     &       1x,'net ',e10.3,2x,e10.3,2x,e10.3,
     &       3x,'plume ems ',e10.3,1x,'|',
     &       1x,'net ',e10.3,2x,e10.3,2x,e10.3,
     &       3x,'plume ems ',e10.3,
     &       /,42x,'exited    ',e10.3,1x,'|',42x,'exited    ',e10.3,
     &       /,20x,'south',38x,'|',20x,'south')
 2135 format(13x,'in  ',1pe10.3,36x,'|',
     &       13x,'in  ',e10.3,/,
     &       13x,'out ',e10.3,15x,'tot mass  ',e10.3,1x,'|',
     &       13x,'out ',e10.3,15x,'tot mass  ',e10.3,/,
     &       13x,'net ',e10.3,36x,'|',
     &       13x,'net ',e10.3,/,63x,'|')
      end
