      subroutine nstfil(cnc1,cnc2,htf1,htf2,nxf1,nyf1,nzf1,
     &                  nxf2,nyf2,nzf2,nsp,if1,if2)
c
c     *** (c) Copr. 1992  Systems Applications, Inc.  San Rafael, CA
c
c$Log: nstfil.f,v $
c  Revision 1.6  2000/07/03  21:45:12  tcm
c  Corrected dimension of cold to irrxyf.
c
c  Revision 1.5  1999/07/07  16:28:40  tcm
c  Added tracking of changes resulting from filling in coarser grid
c  for pa/irr.
c
c  Revision 1.4  1998/11/11  00:11:02  ara
c  Included errlog.cmd file to introduce ierrlg variable
c  Directed error messages to diag file and to log file (ierrlg)
c
c  Revision 1.3  1995/04/26  00:41:46  tcm
c  	modified check of nesting to allow inner grid to extend to edge of outer grid.
c  	modified to handle more complex vertical nesting.
c
c  Revision 1.2  94/02/10  20:58:27  tcm
c  Cosmetic revisions to code by gem, syw, tcm
c  
c
c
c
c  fill in fine grid concentrations with other nested fine grid
c  concentrations.  should be done at end of time step
c  after all transport and chem calculations are done.
c  (tcm, 2/14/91)
c
      include 'parm.cmd'
      include 'parchm.cmd'
      include 'parfin.cmd'
      include 'errlog.cmd'
      dimension cnc1(nxf1,nyf1,nsp,nzf1)
      dimension htf1(nxf1,nyf1,nzf1)
      dimension cnc2(nxf2,nyf2,nsp,nzf2)
      dimension htf2(nxf2,nyf2,nzf2)
      include 'comuam.cmd'
      include 'deffin.cmd'
c
czswa--------------------------------------------------------------------
c  add the emissions into pemis and aemis
c
      include 'irmb.cmd'
      dimension cold(irrxyf,mxspec,mxz)
c
czswz--------------------------------------------------------------------
c
c  set up some parameters relating the two grids
c
      nvr = nvf(if1)/nvf(if2)
      if (nvr .le. 0) then
        write(*,*) ' coarse vertical structure within fine ',
     &             ' vertical structure.',
     &             ' error in nstfil.'
        write(*,*) 'if1, if2: ',if1,if2
        write(8,*) ' coarse vertical structure within fine ',
     &             ' vertical structure.',
     &             ' error in nstfil.'
        write(8,*) 'if1, if2: ',if1,if2
        write(ierrlg,*) 1084,'  coarse vertical structure within fine',
     &             '  vertical structure.',
     &             ' error in nstfil.'
        write(ierrlg,*) 'if1, if2: ',if1,if2
        stop
      endif
      ixff0 = (ixfb(if1) - ixfb(if2))*nhf(if2) + 2
      ixff1 = (ixfe(if1) - ixfb(if2) + 1)*nhf(if2) + 1
      jyff0 = (jyfb(if1) - jyfb(if2))*nhf(if2) + 2
      jyff1 = (jyfe(if1) - jyfb(if2) + 1)*nhf(if2) + 1
      if (ixff0 .lt. 2 .or. ixff1 .ge. nxf2 .or.
     &    jyff0 .lt. 2 .or. jyff1 .ge. nyf2) then
        write(*,*) ' erroneous grid parameters in nstfil'
        write(*,*) ' ixff0, ixff1, jyff0, jyff1: ',ixff0,ixff1,
     &               jyff0, jyff1
        write(*,*) 'if1, if2: ',if1,if2
        write(8,*) ' erroneous grid parameters in nstfil'
        write(8,*) ' ixff0, ixff1, jyff0, jyff1: ',ixff0,ixff1,
     &               jyff0, jyff1
        write(ierrlg,*) 1085,'  erroneous grid parameters in nstfil'
        write(ierrlg,*) ' ixff0, ixff1, jyff0, jyff1: ',ixff0,ixff1,
     &               jyff0, jyff1
        stop
      endif
c
      nhr = nhf(if1)/nhf(if2)
      if (nhr .le. 0) then
        write(*,*) ' coarse horizontal structure within fine ',
     &             ' horizontal structure.',
     &             ' error in nstfil.'
        write(*,*) 'if1, if2: ',if1,if2
        write(8,*) ' coarse horizontal structure within fine ',
     &             ' horizontal structure.',
     &             ' error in nstfil.'
        write(8,*) 'if1, if2: ',if1,if2
        write(ierrlg,*) 1086,'  coarse horizontal structure within',
     &             ' fine horizontal structure.',
     &             ' error in nstfil.'
        write(ierrlg,*) 'if1, if2: ',if1,if2
        stop
      endif
c
czswa---------------------------------------------------------------
c  this part of code is added to calculate the effects of fill-ins
c   from finer grid to fine grid - initialize
c
      do k=1,nzf2
        do n=1,nsp
          do j=jyff0,jyff1
            do i=ixff0,ixff1
              iflgf = iflagf(i,j,if2)
              if (iflgf .gt. 0) then
                cold(iflgf,n,k) = cnc2(i,j,n,k)
              endif
            enddo
          enddo
        enddo
      enddo
c
czswa---------------------------------------------------------------
c
c  zero out coarse grid where overlapped by this fine grid
c
      do 100 k=1,nzf2
        do 90 n=1,nsp
          do 80 j=jyff0,jyff1
            do 70 i=ixff0,ixff1
              cnc2(i,j,n,k) = 0.
   70       continue
   80     continue
   90   continue
  100 continue 
c
c  sum coarse grid for all levels and all species
c
      do 200 k=1,nzf2
        do 190 n=1,nsp
          kf2 = kvmap(k,if1)
          if (k .eq. 1) then
            kf1 = 1
          else
            kf1 = kvmap(k-1,if1) + 1
          endif
          do 180 kf=kf1,kf2
            do 150 j=2,nyf1-1
              jc = jyff0 + (j-2)/nhr
              do 140 i=2,nxf1-1
                if (kf .gt. 1) then
                  delh = htf1(i,j,kf) - htf1(i,j,kf-1)
                else
                  delh = htf1(i,j,kf)
                endif
                vol = delfx(j,if1)*delfy(if1)*delh
                ic = ixff0 + (i-2)/nhr
                cnc2(ic,jc,n,k) = cnc2(ic,jc,n,k)
     &                  + cnc1(i,j,n,kf)*vol
  140         continue
  150       continue
  180     continue
  190   continue
  200 continue
c
c  recalculate conc as concentration instead of mass
c
      do 300 k=1,nzf2
        do 290 n=1,nsp
          do 280 j=jyff0,jyff1
            do 270 i=ixff0,ixff1
              if (k .gt. 1) then
                delh = htf2(i,j,k) - htf2(i,j,k-1)
              else
                delh = htf2(i,j,k)
              endif
              vol = delfx(j,if2)*delfy(if2)*delh
              cnc2(i,j,n,k) = cnc2(i,j,n,k)/vol
  270       continue
  280     continue
  290   continue
  300 continue
c
czswa---------------------------------------------------------------
c  this part of code is added to calculate the effects of fill-ins
c  from finer grid to fine grid - calculate difference
c
      do k=1,nzf2
        do n=1,nsp
          do j=jyff0,jyff1
            do i=ixff0,ixff1
              iflgf = iflagf(i,j,if2)
              if (iflgf .gt. 0) then
                 fillinf(iflgf,n,k) = fillinf(iflgf,n,k) +
     &                   cnc2(i,j,n,k) - cold(iflgf,n,k)
              endif
            enddo
          enddo
        enddo
      enddo
c
czswz---------------------------------------------------------------
c
      return
      end
