      subroutine rchem(deltat,time,idate,idebug)
c
c     *** (c) Copr. 1992  Systems Applications, Inc.  San Rafael, CA
c
c$Log: rchem.f,v $
c  Revision 1.15  1999/12/21  19:28:23  tcm
c  Renamed com3 include file to comd3.
c
c  Revision 1.14  1999/07/07  16:30:28  tcm
c  Added tracking of concentrations before and after chemistry calls
c  for pa/irr treatment.  Modified step4 calls to all irr treatment.
c
c  Revision 1.13  1999/05/18  18:54:57  dfg
c  Added loading radicals and passing it to step4 in temporary diagnostic branch.
c
c  Revision 1.12  1999/05/17  16:28:07  dfg
c  Removed a double calculation for nyr.
c
c  Revision 1.11  1999/05/12  23:41:32  dfg
c  Set ddtt in munutes for all chem routine now.
c
c  Revision 1.10  1999/05/12  16:41:46  dfg
c  Added load back into radical array after step4.
c
c  Revision 1.9  1999/05/12  16:37:08  dfg
c  Added a local radical array.  Radical is loaded before call to step4.
c
c  Revision 1.8  1999/04/08  23:56:11  tcm
c  Added branch based on input flag to use either fast or standard chemistry.
c
c  Revision 1.7  1998/11/20  22:25:03  tcm
c  Fixed format 2812
c
c  Revision 1.6  1998/11/12  16:53:05  ara
c  Included errlog.cmd file to introduce ierrlg variable
c  Directed error message to screen,diag file and log file (ierrlg)
c
c  Revision 1.5  1998/11/04  01:50:05  tcm
c  Eliminated superfluous write of tmpinc.
c  Revised treatment of dates.
c
c  Revision 1.4  1996/06/14  23:02:22  tcm
c   diagnostics added by gem
c
c  Revision 1.3  1995/04/26  00:43:18  tcm
c  	height for calculation of photolysis measured above ground rather than above
c  	sea level.
c
c  Revision 1.2  94/02/10  20:59:22  tcm
c  Cosmetic revisions to code by gem, syw, tcm
c  
c
c
c     ***  Chemistry driver for the coarse domain
c
      include 'parm.cmd'
      include 'parchm.cmd'
      include 'parfin.cmd'
      include 'deffin.cmd'
      include 'comuam.cmd'
      include 'comchem.cmd'
      include 'comd3.cmd'
      include 'ppmcon.cmd'
      include 'errlog.cmd'
c
czswa-------------------------------------------------------------------
c  don't forget to include irmb
c
      include 'irmb.cmd'
c
czswz-------------------------------------------------------------------
c
      dimension cllvol(mxx,mxy,mxz)
      dimension con(mxspec),oldcon(mxspec),rcon(mxrads)
      integer ichk(100), jchk(100), kchk(100)
c
      dimension cmax(mxz),cmin(mxz),cavg(mxz)
      dimension icmax(mxz),icmin(mxz),icavg(mxz)
      dimension ilmax(mxz), jlmax(mxz), ilmin(mxz), jlmin(mxz)
      common /idcell/irchem,jrchem,krchem,tmchm
      common /ppp/ lcprt, lcstop
      logical lcprt, lcstop,llpt
      data ichmag/0/
c
c  bit nine of idebug on (i.e., the two-hundred fifty-sixes location) 
c  will turn on debug writes in rchem.
c
      llpt=.false.
      idiag = and(idebug,256)
c
      tmchm = time
c
c  temporary diagnostic
c
      if (idiag .ne. 0) then
        val=conc(20,20,ko3,1)*1000.0
        write(*,*) ' entering rchem conc(20,20,ko3,1) is ',val
        val=conc(20,20,kco,1)*1000.0
        write(*,*) ' entering rchem conc(20,20,kco,1) is ',val
      endif
c
c     write max,minmavg ozone to diagnostic output file
c
      do 2 l=1,nlayer
        cmax(l)=-1.e20
        cmin(l)=1.e20
        cavg(l)=0.0
        ilmax(l) = 0
        jlmax(l) = 0
        ilmin(l) = 0
        jlmin(l) = 0
    2 continue
c
      denom=0.0
      do 5 j=2,noy-1
        i1=istr(j)+1
        i2=iend(j)-1
        if (i2.lt.i1) go to 5
        do 4 i=i1,i2
          do 3 l=1,nlayer
            val=conc(i,j,ko3,l)*1000.0*cpfac
            cavg(l)=cavg(l)+val
            if (val .gt. cmax(l)) then
              cmax(l)=val
              ilmax(l) = i
              jlmax(l) = j
            endif
            if (val .lt. cmin(l)) then
              cmin(l)=val
              ilmin(l) = i
              jlmin(l) = j
            endif
    3     continue
          denom=denom+1.0
    4   continue
    5 continue
c
      do 6 l=1,nlayer
        cavg(l)=cavg(l)/denom
        icmax(l)=nint(cmax(l))
        icmin(l)=nint(cmin(l))
        icavg(l)=nint(cavg(l))
    6 continue
      write(*,3001) time,idate,(icmax(l),icmin(l),icavg(l),l=1,nlayer)
      write(*,3002) (ilmax(l),jlmax(l),ilmin(l),jlmin(l),l=1,nlayer)
 3001 format('rchem',f10.2,i10,9i4,/,(25x,9i4))
 3002 format(' at ',20x, 2i4, 5x,2i4)
c
c     extract date
c
      if (idate .lt. 100000) then
        call jtocal(idate,icdate)
        nyr=icdate/10000
        nmth=icdate/100-nyr*100
        nday=icdate-nmth*100-nyr*10000
      else
        nyr=idate/10000
        nmth=idate/100-nyr*100
        nday=idate-nmth*100-nyr*10000
      endif
c     nyr=nyr+1900    ! removed this extra conversion (5/17/99, dfg)
      if (nyr .lt. 100) then
        if (nyr .lt. 51) then
          nyr = nyr + 2000
        else
          nyr = nyr + 1900
        endif
      endif
c
c%% optimization code
      dmin=1.e20
      dmax=-1.e20
      davg=0.0
      tmin=1.e20
      tmax=-1.e20
      tavg=0.0
      kntt=0
      rmax=-1.e20
      rmin=1.e20
      ravg=0.0
      kntr=0
c%%
c
czswa---------------------------------------------------------------
c  let's do some mass tracking
c
      call get_difc (4,1,1)
c
c  done
czswz-----------------------------------------------------------------
c
c----------------------------------------
c     go through 100 loop only if lchmag=f
c     otherwise, do aggregate chemistry
c     (2790 loop)
c-----------------------------------------
      if(lchmag) go to 190
c
c     chemistry rates are set up in minutes
c
      ddtt = deltat 
c
c     loop on grids
c
      do 100 j=1,noy
        jrchem = j
        if (istr(j).ge.nox) go to 100
        i1=istr(j)+1
        i2=iend(j)-1
        do 99 i=i1,i2
          if (j.le.jstr(i)) go to 99
          if (j.ge.jend(i)) go to 99
c
c      skip cells covered by fine grid
c
          do 7 ifine=1,numfin
            if (i .ge. ixfb(ifine) .and. i .le. ixfe(ifine)
     &         .and. j .ge. jyfb(ifine) .and. j .le. jyfe(ifine))
     &                                                   go to 99
    7     continue
          irchem=i
c
c         do chemistry in layer k
c
          hgtemp=0.
          do 90 k=1,nlayer
            krchem=k
c
c           obtain current no2 photolysis rate factor for this height
c
c012595  height for calculation of photolysis rates should be
c012595  above ground rather than above sea level (tcm)
c012595     zavght=hgtemp+(1000.0*h(i,j,k)-hgtemp)/2.+avterr(i,j)
            zavght=hgtemp+(1000.0*h(i,j,k)-hgtemp)/2.
            hgtemp=1000.*h(i,j,k)
c
c...    need to get pressure from meteorology model.
c
            pcell=press(i,j,k)
c%%%
c
c           calculate temperture dependent rates
c
            tcell=temper(i,j,k)+tmpinc
            call tdrate(nreact,tcell,pcell)
            call phot(time,nyr,nmth,nday,i,j,k,zavght,factor,ldark)
c%%%
            rmax=amax1(rmax,factor)
            rmin=amin1(rmin,factor)
            ravg=ravg+factor
            kntr=kntr+1
c
czswa---------------------------------------------------------------------
c
c  some parts of the code is modified, it's easier to rewrite the whole block
c  the variables added are
c     aam2c : mass          ---> concentration
c     aac2m : concentration ---> mass
c     iflg  : iflag(i,j)
c
c     load layer-average concentrations into con array
c
            iflg  = iflag(i,j)
            aam2c = cpfac*tcell/(273.*pcell)
            aac2m = pcell*273./(tcell*cpfac)
c
            do 10 l=1,nospec
              con(l)=conc(i,j,l,k)*aam2c
   10       continue
c
            h2o=ch2o(i,j,k)
            cwc=cwater(i,j,k)
c
c     do chemistry
c
	    if ( idiag .ne. 0 ) then
		write(*,*) ' calling step4, ', i,j,k
		write(*,*) dmax,dmin,davg,dtuse,kntt
		write(*,*) ' tmax,tmin,tavg,itmax '
		write(*,*) tmax,tmin,tavg,itmax
	    endif
c
c  load radical concentrations (dfg, 05/11/99)
c
            llx = i + nox*(j-1) + nox*noy*(k-1)
            do ll=1,mxrads
              rcon(ll)=radcon(ll,llx)
            end do
c
c           lcprt = .false.
c           if (i.eq.36 .and. j.eq.38 .and. k.eq.6) lcprt = .true.
            lcstop = .false.
            if (lchfast) then
              call step4f(nospec,nospec,ddtt,con,lerror,tcell,rcon,llpt,
     &                 1,iflg,k,aac2m)
            else
              call step4(nospec,nospec,ddtt,con,lerror,tcell,rcon,llpt,
     &                 1,iflg,k,aac2m)
            endif
c
	    if ( idiag .ne. 0 ) then
		write(*,*) ' dmax,dmin,davg,dtuse,kntt '
		write(*,*) dmax,dmin,davg,dtuse,kntt
		write(*,*) ' tmax,tmin,tavg,itmax '
		write(*,*) tmax,tmin,tavg,itmax
	    endif
c
            if (lerror) go to 810
c
            dmax=amax1(dmax,dtuse)
            dmin=amin1(dmin,dtuse)
            davg=davg+dtuse
            kntt=kntt+1
            tmax=amax1(tmax,float(itmax))
            tmin=amin1(tmin,float(itmax))
            tavg=tavg+itmax
c
	    if ( idiag .ne. 0 ) then
		write(*,*) ' dmax,dmin,davg,dtuse,kntt '
		write(*,*) dmax,dmin,davg,dtuse,kntt
		write(*,*) ' tmax,tmin,tavg,itmax '
		write(*,*) tmax,tmin,tavg,itmax
	    endif
c
c
c           load back into conc array
c
            do 20 l=1,nospec
              conc(i,j,l,k)=con(l)*aac2m
   20       continue
c
czswz-------------------------------------------------------------------
c
c  Load back into radical array. (5/12/99, dfg)
            do l=1,mxrads
              radcon(l,llx)=rcon(l)
            enddo
c
c
c     end of loop on layers
c
   90     continue
c
c     end loop on grids
c
   99   continue
  100 continue
c
czswa-----------------------------------------------------------------
c  let's finish up on the mass tracking
c
      call get_difc (4,2,1)
c
c  done
c
c*** careful ***
c  the integrated reaction rate needs to be fixed for the aggregate cells
c  (nothing's easy here), sigh ................
c
czswz-----------------------------------------------------------------
c
      if(.not.lchmag) go to 800
c-----------------------------------
c  ** aggregate cell chemistry loop
c------------------------------------
c
  190 ichmag=ichmag+1
      if(ichmag.lt.ifix(chmint)) return
      ichmag=0
      ddtt=chmint*deltat
c---------------------------------------------
c     loop over aggregate grids.  zero temporary
c     concentration arrays and other variables
c     used to store aggregate cell information.
c----------------------------------------------
      do 2790 icm=1,ncm
        irchem=icmb(icm)
        jrchem=jcmb(icm)
        krchem=kcmb(icm)
c
c   skip this if it is covered by a fine grid
c
        do 203 ifine=1,numfin
          if (irchem .ge. ixfb(ifine) .and. irchem .le. ixfe(ifine)
     &    .and. jrchem .ge. jyfb(ifine) .and. jrchem .le. jyfe(ifine))
     &                                                   go to 2790
  203   continue
c
      do 201 l=1,nospec
        con(l)=0.
  201 continue 
      h2o=0.
      cwc=0.
      avhtag=0.
      factag=0.
      tcell=0.
      pcell=0.
      volcll=0.
      harea=0.
c--------------------------------------------------
c     from within the range of the aggregate cells,
c     calculate aggregate cell concentration, ag-
c     gregate cell height, pholotysis factor, and
c     volume, and some other things
c------------------------------------------------
      iavg=0
      javg=0
      kavg=0
      do 251 j=jcmb(icm),jcme(icm)
        javg=javg+j
        do 250 i=icmb(icm),icme(icm)
          if(j.eq.jcmb(icm)) iavg=iavg+i
c---------------------------
c     increment quantities
c---------------------------
          harea=harea+deltax(j)*deltay
          hgtemp=0.
         if(kcmb(icm).gt.1) hgtemp=1000.*h(i,j,kcmb(icm)-1)
c012595  height for calculation of photolysis rates should be
c012595  above ground rather than above sea level (tcm)
c012595  avhtag=avhtag+deltax(j)*deltay*
c0125&     (  (1000.*h(i,j,kcme(icm))+hgtemp)/2.+avterr(i,j) )
         avhtag=avhtag+deltax(j)*deltay*
     &     (  (1000.*h(i,j,kcme(icm))+hgtemp)/2. )
c        avhsav=  (1000.*h(i,j,kcme(icm))+hgtemp)/2.+avterr(i,j) 
c
          do 245 k=kcmb(icm),kcme(icm)
            if(i.eq.icmb(icm) .and. j.eq.jcmb(icm))kavg=kavg+k
            cllvol(i,j,k)=(1000.*h(i,j,k)-hgtemp)*deltax(j)*deltay
            hgtemp=1000.*h(i,j,k)
            tcell=tcell+(temper(i,j,k)+tmpinc)*cllvol(i,j,k)
            pcell=pcell+press(i,j,k)*cllvol(i,j,k)
            volcll=volcll+cllvol(i,j,k)
            h2o=h2o+ch2o(i,j,k)*cllvol(i,j,k)
            cwc=cwc+cwater(i,j,k)*cllvol(i,j,k)
c----------------------------------------------------------------------
c  option 1 & 3: con and radicals loaded by volume weighting
c----------------------------------------------------------------------
            if (ismth.eq.1.or.ismth.eq.3) then
              do 2401 l = 1,nospec
                con(l) = con(l) + conc(i,j,l,k)*cllvol(i,j,k)
 2401         continue
c-------------------------------------------------------------------------
c  option 2: conc and crad must themselves become become volume weighted
c-------------------------------------------------------------------------
            elseif (ismth.eq.2) then
              do 240 l=1,nospec
                cccc=conc(i,j,l,k)*cllvol(i,j,k)
                conc(i,j,l,k)=cccc
                con(l)=con(l)+cccc
  240         continue
            endif
c
  245     continue
  250   continue
  251 continue
      totcell = float((icme(icm)-icmb(icm)+1)*(jcme(icm)-jcmb(icm)+1)*
     &          (kcme(icm)-kcmb(icm)+1))
c------------------------------------------------
c     determine aggregate averages.  
c---------------------------------------------------------------------
c     option 2: the inner loop determines mass ratios 
c     of individual to aggregate grid cells (now stored in conc)
c---------------------------------------------------------------------
      if (ismth.eq.2) then
        do 261 k=kcmb(icm),kcme(icm)
          do 260 j=jcmb(icm),jcme(icm)
            do 259 i=icmb(icm),icme(icm)
              do 258 l=1,nospec
                conc(i,j,l,k)=conc(i,j,l,k)/con(l)
  258         continue
  259       continue
  260     continue
  261   continue
      endif
c
      h2o=h2o/volcll
      cwc=cwc/volcll
      tcell=tcell/volcll
      pcell=pcell/volcll
      avhtag=avhtag/harea
      javg=javg/(jcme(icm)+1-jcmb(icm))
      iavg=iavg/(icme(icm)+1-icmb(icm))
      kavg=kavg/(kcme(icm)+1-kcmb(icm))
      do 262 l=1,nospec
        oldcon(l) = con(l)/volcll
        con(l)=(con(l)/volcll)*cpfac*tcell/(273.*pcell)
  262 continue
c-------------------------------------------
c     calculate temperature dependent rates
c-------------------------------------------
        if (idiag .ne. 0) then
          write(*,7002) tcell
 7002     format(' call tdrate',f10.1)
        endif
      call tdrate(nreact,tcell,pcell)
c-----------------------------------------------------
c    obtain current no2 photolysis rates for the
c    aggregate cell height
c-----------------------------------------------------
      if (idiag .ne. 0) then
        write(*,7001) iavg,javg,kavg,avhtag
 7001   format(' call phot',3i3,e12.4)
      endif
c     if (avhtag .ne. avhsav) then
c       write(*,7071) iavg,javg,kavg,avhtag,avhsav
c7071   format(' call phot',3i3,2e12.4)
c     endif
      call phot(time,nyr,nmth,nday,iavg,javg,kavg,avhtag,factor,ldark)
c
c  temporary diagnostic
c
      if (idiag .ne. 0) then 
        if (iabs(iavg-20).lt.2 .and. iabs(javg-20).lt.2
     &                             .and. kavg .eq. 1) then
        write(*,*) ' after phot factor is ',factor
        endif
      endif
      rmax=amax1(rmax,factor)
      rmin=amin1(rmin,factor)
      ravg=ravg+factor
      kntr=kntr+1
c------------------
c     do chemistry
c------------------
c
c  temporary diagnostic
c
      if (idiag .ne. 0) then
        if (iabs(iavg-20).lt.2 .and. iabs(javg-20).lt.2
     &                             .and. kavg .eq. 1) then
          vvv=con(ko3)*1000.0
          write(*,*) ' before step4 conc(20,20,ko3,1) is ',vvv
          vvv=con(kco)*1000.0
          write(*,*) ' before step4 conc(20,20,kco,1) is ',vvv
        endif
      endif
      if (idiag .ne. 0) then
        write(*,7011) kavg,iavg,javg,ddtt,factor,ldark
 7011   format(' call step4 layer ',i2,' grid ',2i5,2e12.4,l5)
        write(*,7003) ddtt,h2o,factor,tcell,ldark,nutrc,con
 7003   format(' call step4',4e12.4,l5,i5,/,5(7e11.3))
      endif
c
c  load radical concentrations (5/18/99, dfg)
            llx = iavg + nox*(javg-1) + nox*noy*(kavg-1)
            do ll=1,mxrads
              rcon(ll)=radcon(ll,llx)
            end do
czswa-------------------------------------------------------------------
c  old step4 replaced with new call needs to be worked on
c
c
      if (lchfast) then
        call step4f(nospec,nospec,ddtt,con,lerror,tcell,rcon,llpt,
     &                 1,iflg,k,aac2m)
      else
        call step4(nospec,nospec,ddtt,con,lerror,tcell,rcon,llpt,
     &                 1,iflg,k,aac2m)
      endif
czswz-------------------------------------------------------------------
c
      if (idiag .ne. 0) then
        write(*,7004)
 7004   format(' aft call step4')
      endif
c
c  temporary diagnostic
c
      if (idiag .ne. 0) then
        if (iabs(iavg-20).lt.2 .and. iabs(javg-20).lt.2
     &                               .and. kavg .eq. 1) then
          vvv=con(ko3)*1000.0
          write(*,*) ' after step4 conc(20,20,ko3,1) is ',vvv
          vvv=con(kco)*1000.0
          write(*,*) ' after step4 conc(20,20,kco,1) is ',vvv
        endif
      endif
      do 264 l=1,nospec
        con(l)=con(l)*pcell*273./(tcell*cpfac)
  264 continue
c
c  Load back radicals  (5/18/99, dfg)
c
      do l=1,mxrads
        radcon(l,llx)=rcon(l)
      enddo

      if(lerror) go to 810
      dmax=amax1(dmax,dtuse)
      dmin=amin1(dmin,dtuse)
      davg=davg+dtuse
      kntt=kntt+1
      tmax=amax1(tmax,float(itmax))
      tmin=amin1(tmin,float(itmax))
      tavg=tavg+itmax
c--------------------------------------------------------------------------
c  option 1: disaggregate concentrations back to individual
c  cells.  this is done by adding the difference between pre-chem
c  value of con(l) and post-chem value of con(l) to each grid cell.
c  this is "gradient conserving".
c--------------------------------------------------------------------------
      if (ismth.eq.1) then
        do 268 k=kcmb(icm),kcme(icm)
          do 267 j=jcmb(icm),jcme(icm)
            do 266 i=icmb(icm),icme(icm)
              do 265 l=1,nospec
                if (con(l).gt.bdmol(l)) then
                  conc(i,j,l,k)=conc(i,j,l,k) + (con(l) - oldcon(l))
                else
                  conc(i,j,l,k) = bdmol(l)
                endif
  265         continue
  266       continue
  267     continue
  268   continue
c--------------------------------------------------------------------
c  check to make sure concentration does not go below bdmol value;
c  if it does, add mass to get to bdmol value, and remove the same
c  amount of mass (divided equally) from the rest of the grid cells
c  in this aggregate cell.
c--------------------------------------------------------------------
        do 2770 l=1,nospec
          icnt = 0
  270     diffmass = 0.
          do 2742 k=kcmb(icm),kcme(icm)
            do 2741 j=jcmb(icm),jcme(icm)
              do 2740 i=icmb(icm),icme(icm)
                if (conc(i,j,l,k).lt.bdmol(l)) then
                  icnt = icnt + 1
                  ichk(icnt) = i
                  jchk(icnt) = j
                  kchk(icnt) = k
                  diffmass = diffmass + cllvol(i,j,k)*
     &                  (bdmol(l) - conc(i,j,l,k))
                  conc(i,j,l,k) = bdmol(l)
                endif
 2740         continue
 2741       continue
 2742     continue
          if (diffmass.ne.0..and.totcell.ne.1.) then
            diffmass = diffmass/(totcell - float(icnt))
            do 2767 k=kcmb(icm),kcme(icm)
              do 2766 j=jcmb(icm),jcme(icm)
                do 2756 i=icmb(icm),icme(icm)
                  do 2755 n = 1,icnt 
                    if (i.eq.ichk(n).and.j.eq.jchk(n).and.k.eq.kchk(n))
     &                                                     go to 2756
 2755             continue
                  conc(i,j,l,k) = conc(i,j,l,k) - diffmass/cllvol(i,j,k)
 2756           continue
 2766         continue
 2767       continue
            goto 270
          endif
 2770   continue
c---------------------------------------------------------------------
c     option 2: disaggregate concentrations back to individual
c     cells.  this is done by multiplying the 
c     aggregate cell mass by the mass ratio determined
c     in the 260-, 261- loops.  this is not "gradient conserving"
c---------------------------------------------------------------------
      elseif (ismth.eq.2) then
        do 2774 k=kcmb(icm),kcme(icm)
          do 2773 j=jcmb(icm),jcme(icm)
            do 2772 i=icmb(icm),icme(icm)
              do 2771 l=1,nospec
                conc(i,j,l,k)=con(l)*volcll*conc(i,j,l,k)/cllvol(i,j,k)
 2771         continue
 2772       continue
 2773     continue
 2774   continue
c--------------------------------------------------------------------
c     option 3: disaggregate concentrations back into indivdual
c     cells uniformly.  this gives a flat field for the cells in
c     the current aggregate cell.
c--------------------------------------------------------------------
      else
        do 2784 k=kcmb(icm),kcme(icm)
          do 2783 j=jcmb(icm),jcme(icm)
            do 2782 i=icmb(icm),icme(icm)
              do 2781 l=1,nospec
                conc(i,j,l,k)=con(l)
 2781         continue
c
c  temporary diagnostic
c
              if (idiag .ne. 0) then
                if (iabs(i-20).lt.1 .and. iabs(j-20).lt.1
     &                                .and. k .eq. 1) then
                  vvv=conc(20,20,ko3,1)*1000.0
                  write(*,*) ' after disagg conc(20,20,ko3,1) is ',vvv
                  vvv=conc(20,20,kco,1)*1000.0
                  write(*,*) ' after disagg conc(20,20,kco,1) is ',vvv
                endif
              endif
 2782       continue
 2783     continue
 2784   continue
      endif
c----------------------
c     that's it for
c     aggregate icm
c---------------------
 2790 continue
c
czswa-----------------------------------------------------------------
c  let's finish up on the mass tracking
c
	    if ( idiag .ne. 0 ) then
		write(*,*) ' dmax,dmin,davg,dtuse,kntt '
		write(*,*) dmax,dmin,davg,dtuse,kntt
		write(*,*) ' tmax,tmin,tavg,itmax '
		write(*,*) tmax,tmin,tavg,itmax
	    endif
      print *,' Aggregate chemistry here ..........'
      call get_difc (4,2,1)
c
c  done
czswz-----------------------------------------------------------------
c
c
  800 continue
      davg=davg/float(kntt)
      tavg=tavg/float(kntt)
      write(*,3000) time,idate,deltat,ddtt,dmax,dmin,davg,tmax,
     & tmin,tavg,kntt
 3000 format(f8.0,i10,f5.1,7e12.4,i15)
c
      ravg=ravg/float(kntr)
      write(*,3100) time,idate,rmax,rmin,ravg
 3100 format(f8.0,i10,' In rchem, k1 range=',3e12.4)
      write(66,3000) time,idate,deltat,ddtt,dmax,dmin,davg,tmax,
     & tmin,tavg,kntt   
      write(66,3100) time,idate,rmax,rmin,ravg
c%%%
c
c
c  temporary diagnostic
c
      if (idiag .ne. 0) then
        val=conc(20,20,ko3,1)*1000.0
        write(*,*) ' leaving rchem conc(20,20,ko3,1) is ',val
        val=conc(20,20,kco,1)*1000.0
        write(*,*) ' leaving rchem conc(20,20,kco,1) is ',val
      endif
      return
c
c     error in chemistry
c
  810 continue
      write(66,2810) k,i,j,factor,time,nyr,nmth,nday,zavght,con
      write(*,2810) k,i,j,factor,time,nyr,nmth,nday,zavght,con 
      write(8,2810) k,i,j,factor,time,nyr,nmth,nday,zavght,con
      write(ierrlg,2812) 1095,k,i,j,factor,time,nyr,nmth,nday,
     &    zavght,con
 2810 format(' $$error in chemistry layer ',i2,' grid',2i5,f10.4
     &,      f10.2,3i5,e12.4/1x,10e12.4/1x,10e12.4/1x,10e12.4)
 2812 format(i4,1x,' $$error in chemistry layer ',i2,' grid',2i5,f10.4
     &,      f10.2,3i5,e12.4/1x,10e12.4/1x,10e12.4/1x,10e12.4)
      write(66,2811) h2o,tcell,ddtt,ldark
 2811 format(3e12.4,l10)
      stop6
      end
