c***************************************************************
      real function sigmay (x,sigy0,is,iinit)
c
c     *** (c) Copr. 1992  Systems Applications, Inc.  San Rafael, CA
c
c$Log: sigmay.f,v $
c  Revision 1.3  1996/06/14  23:03:52  tcm
c   minimum sigma y value check added by gem
c
c  Revision 1.2  1994/02/10  21:00:19  tcm
c  Cosmetic revisions to code by gem, syw, tcm
c
c
c
c
c         returns the horizontal dispersion coefficient (sigma y)
c         (tcm, 11/19/91, from a program by
c             gw lundberg/sai  july 1988)
c
c         arguments--
c         x      downwind distance (or distance increment) in meters 
c         sigy0  current sigmay
c         is     the stability class (1=a,...,6=f)
c         iinit  flag to indicate whether this call is to 
c                initialize (=0 means initialize)
c
c         uses seinfelds equations for the pasquill-gifford curves
c         reference: see function sigmaz
c          
c         for iinit = 1, caculate alogx by reversing the equation
c         and then calculate sigmay
c
c     --------------------------------------------------------
c
      real a(6),b(6),c(6),symax(6),symin(6)
      data a/-1.104,-1.634,-2.054,-2.555,-2.754,-3.143/
      data b/0.9878,1.0350,1.0231,1.0423,1.0106,1.0148/
      data c/-0.0076,-0.0096,-0.0076,-0.0087,-0.0064,-0.0070/
      data symax /10520.8,8179.79,6108.97,3990.85,3079.92,2023.32/
      data symin /26.6772,18.7044,12.1384,7.8496,5.8372,3.9824/
c
c     ---------------------------------------------------------
      if (iinit .eq. 0) then
        alogx = alog(x)
        sigmay = exp(a(is) + b(is)*alogx + c(is)*alogx*alogx)
c
      else if (iinit .eq. 1) then 
	if (sigy0 .lt. symin(is)) then
	   xx=amax1(x,100.)
	   alogx=alog(xx)
           sigmay = exp(a(is) + b(is)*alogx + c(is)*alogx*alogx)
c
c      if sigma is larger than maximum from formula for this
c      stability class, calculate an increment by tagging the
c      x increment onto 10**5
c
        elseif (sigy0 .gt. symax(is)) then
          xx = 1.e5 + x
          alogx = alog(xx)
          signew = exp(a(is) + b(is)*alogx + c(is)*alogx*alogx)
          sigmay = sigy0 + (signew - symax(is))
        else
          alsig = alog(sigy0)
          alogx = (-b(is) + sqrt(b(is)**2 - 4.*c(is)*
     &           (a(is)-alsig)))/(2.*c(is))
          if (alogx .lt. 0.) stop63
          xx = exp(alogx) + x
          if (xx .lt. 1.) stop64
          alogx = alog(xx)
          sigmay = exp(a(is) + b(is)*alogx + c(is)*alogx*alogx)
        endif
      else
        stop65
      endif
c
      if (sigmay .lt. 1.) stop66
      if (iinit .eq. 1 .and. sigmay .lt. sigy0) stop67
      return
      end
