      SUBROUTINE slowdr(NOSPEC,HH,HR,RATE,JAC)
 
c   *** Generated from DFG's VBChemG software, Dongfen Gao, 5/18/1999
 
c$Log: slowdr.f,v $
c Revision 1.3  2002/06/26  20:44:13  tcm
c revised +- syntax to +(-  ) for better portability
c
c Revision 1.2  1999/09/25  00:13:09  tcm
c Added NTR as product of reaction 55 (and 68 if NPHN not simulated).
c
c Revision 1.1  1999/06/24  00:05:20  dfg
c Initial revision
c

      INCLUDE  'parchm.cmd'
      INCLUDE  'comchem.cmd'

      DIMENSION  RATE(MXSPEC), HH(MXSPEC), HR(MXRADS)
      DIMENSION JAC(MXSPEC,MXSPEC)
      REAL JAC
      REAL NO, NO2, O3, OLE, PAR, TOL, XYL, HCHO, ACET, ETH, 
     & CRES, MGLY, OPEN, PNA, PAN, CO, HNO2, H2O2, HNO3, ISOP, 
     & SO2, SULF, MEOH, ETOH, MTBE, NPHN, ALDX, IOLE, PANX, CH4, 
     & NTR, ISPD, PHCHO, PACET, O1D, O, NO3, N2O5, HO2, OH, C2O3, 
     & CXO3, XO2, XO2N, TO2, ROR, CRO
c*************************************************
c     INPUT OF CONCENTRATION DATA -- PPM UNIT
c*************************************************
      SO2  = 0.
      SULF = 0.
      MEOH = 0.
      ETOH = 0.
      ISOP = 0.
      ISPD = 0.
      MTBE = 0.
      NPHN = 0.
      NO = HH(KNO)
      NO2 = HH(KNO2)
      O3 = HH(KO3)
      OLE = HH(KOLE)
      PAR = HH(KPAR)
      TOL = HH(KTOL)
      XYL = HH(KXYL)
      HCHO = HH(KHCHO)
      ACET = HH(KACET)
      ETH = HH(KETH)
      CRES = HH(KCRES)
      MGLY = HH(KMGLY)
      OPEN = HH(KOPEN)
      PNA = HH(KPNA)
      PAN = HH(KPAN)
      CO = HH(KCO)
      HNO2 = HH(KHNO2)
      H2O2 = HH(KH2O2)
      HNO3 = HH(KHNO3)
      IF (LISOP) ISOP = HH(KISOP)
      IF (LSO2) SO2 = HH(KSIV)
      IF (LSO2) SULF = HH(KSULF)
      IF (LMEOH) MEOH = HH(KMEOH)
      IF (LETOH) ETOH = HH(KETOH)
      IF (LMTBE) MTBE = HH(KMTBE)
      IF (LNPHN) NPHN = HH(KNPHN)
      ALDX = HH(KALDX)
      IOLE = HH(KIOLE)
      PANX = HH(KPANX)
      CH4 = HH(KCH4)
      IF (LNITR) NTR = HH(KNITR)
      IF (LISOP) ISPD = HH(KISPD)
      PHCHO = 0.
      PACET = 0.
      If (LPHCH) Then
        PHCHO = HH(KPHCH)
        PACET = HH(KPACT)
      End If
      O1D = HR(KO1D)
      O = HR(KO)
      NO3 = HR(KNO3)
      N2O5 = HR(KN2O5)
      HO2 = HR(KHO2)
      OH = HR(KOH)
      C2O3 = HR(KC2O3)
      CXO3 = HR(KCXO3)
      XO2 = HR(KXO2)
      XO2N = HR(KXO2N)
      TO2 = HR(KTO2)
      ROR = HR(KROR)
      CRO = HR(KCRO)
      kso2 = ksiv
      kntr = knitr
c
c     *** zero out rate for state species. 
c 
       do 100 i=1,nospec
          rate(i) = 0. 
 100   continue
c
c      Calculating the rate for state species
c
      Sink =   - rk(3)*O3  - rk(6)*O  - rk(15)*NO3
     &   - rk(20)*NO  - rk(20)*NO  - rk(21)*NO2*H2O
     &   - rk(22)*OH  - rk(28)*HO2  - rk(46)*C2O3
     &   - rk(64)*TO2  - rk(79)*XO2  - rk(81)*XO2N
     &   - rk(98)*CXO3
      Source = 1.*rk(1)*NO2 +1.*rk(4)*O*NO2
     &  +.11*rk(14)*NO3 +1.*rk(16)*NO3*NO2
     &  +1.*rk(23)*HNO2 +1.*rk(25)*HNO2*HNO2
     &  +1.*rk(64)*TO2*NO +.2*rk(109)*NO2*ISOP
      Rate(kNO) = Source + Sink*NO
      Sink =   - rk(1)  - rk(4)*O  - rk(5)*O
     &   - rk(7)*O3  - rk(16)*NO3  - rk(17)*NO3
     &   - rk(21)*NO*H2O  - rk(26)*OH  - rk(29)*HO2
     &   - rk(47)*C2O3  - rk(55)*ROR  - rk(68)*CRO
     &   - rk(99)*CXO3  - rk(109)*ISOP
      Source = 1.*rk(3)*O3*NO +1.*rk(6)*O*NO
     &  +.89*rk(14)*NO3 +2.*rk(15)*NO3*NO
     &  +1.*rk(16)*NO3*NO2 +1.*rk(19)*N2O5
     &  +2.*rk(20)*NO*NO +1.*rk(24)*OH*HNO2
     &  +1.*rk(25)*HNO2*HNO2 +1.*rk(28)*HO2*NO
     &  +1.*rk(30)*PNA +1.*rk(31)*OH*PNA
     &  +1.*rk(46)*C2O3*NO +1.*rk(48)*PAN
     &  +1.*rk(59)*NO3*OLE +.2*rk(78)*NO3*ISOP
     &  +1.*rk(79)*XO2*NO +1.*rk(97)*IOLE*NO3
     &  +1.*rk(98)*CXO3*NO +1.*rk(100)*PANX
     &  +1.*rk(103)*PANX*OH
      Rate(kNO2) = Source + Sink*NO2
      Sink =   - rk(3)*NO  - rk(7)*NO2  - rk(8)
     &   - rk(9)  - rk(12)*OH  - rk(13)*HO2
     &   - rk(58)*OLE  - rk(62)*ETH  - rk(71)*OPEN
     &   - rk(77)*ISOP  - rk(96)*IOLE  - rk(106)*ISPD
      Source = 1.*rk(2)*O +.33*rk(50)*C2O3*HO2
     &  +.33*rk(102)*CXO3*HO2
      Rate(kO3) = Source + Sink*O3
      Sink =   - rk(56)*O  - rk(57)*OH  - rk(58)*O3
     &   - rk(59)*NO3
      Source = 0.
      Rate(kOLE) = Source + Sink*OLE
      Sink =   - rk(52)*OH
      Source = -.11*rk(52)*PAR*OH +(-2.1)*rk(53)*ROR
     &  +.22*rk(56)*O*OLE +(-1.)*rk(57)*OH*OLE
     &  +(-1.)*rk(58)*O3*OLE +(-1.)*rk(59)*NO3*OLE
     &  +1.1*rk(72)*OH*XYL +.25*rk(75)*O*ISOP
     &  +.35*rk(77)*O3*ISOP +2.4*rk(78)*NO3*ISOP
     &  +(-1.)*rk(90)*ALDX*O +(-1.)*rk(91)*ALDX*OH
     &  +(-1.)*rk(92)*ALDX*NO3 +(-1.)*rk(93)*ALDX
     &  +.1*rk(94)*IOLE*O +1.565*rk(105)*OH*ISPD
     &  +.36*rk(106)*O3*ISPD +1.282*rk(107)*NO3*ISPD
     &  +.832*rk(108)*ISPD +2.4*rk(109)*NO2*ISOP
     &  +.97*rk(110)*MTBE*OH
      Rate(kPAR) = Source + Sink*PAR
      Sink =   - rk(63)*OH
      Source = 0.
      Rate(kTOL) = Source + Sink*TOL
      Sink =   - rk(72)*OH
      Source = 0.
      Rate(kXYL) = Source + Sink*XYL
      Sink =   - rk(37)*OH  - rk(38)  - rk(39)
     &   - rk(40)*O  - rk(41)*NO3
      Source = 1.*rk(45)*ACET +1.*rk(46)*C2O3*NO
     &  +2.*rk(49)*C2O3*C2O3 +1.*rk(51)*CH4*OH
     &  +.2*rk(56)*O*OLE +1.*rk(57)*OH*OLE
     &  +.74*rk(58)*O3*OLE +1.*rk(59)*NO3*OLE
     &  +1.*rk(60)*O*ETH +1.56*rk(61)*OH*ETH
     &  +1.*rk(62)*O3*ETH +1.*rk(70)*OPEN*OH
     &  +.7*rk(71)*OPEN*O3 +.5*rk(75)*O*ISOP
     &  +.629*rk(76)*OH*ISOP +.6*rk(77)*O3*ISOP
     &  +.078*rk(82)*ETOH*OH +1.*rk(84)*MEOH*OH
     &  +1.*rk(85)*MEOH*NO3 +.25*rk(96)*IOLE*O3
     &  +1.*rk(101)*CXO3*C2O3 +.167*rk(105)*OH*ISPD
     &  +.15*rk(106)*O3*ISPD +.282*rk(107)*NO3*ISPD
     &  +.9*rk(108)*ISPD +.42*rk(110)*MTBE*OH
      if (LPHCH) Rate(kPHCH)=FPF*sink*HCHO
      Rate(kHCHO) = Source + FSF*Sink*HCHO
      Sink =   - rk(42)*O  - rk(43)*OH  - rk(44)*NO3
     &   - rk(45)
      Source = .06*rk(52)*PAR*OH +.6*rk(53)*ROR
     &  +.24*rk(56)*O*OLE +.38*rk(57)*OH*OLE
     &  +.19*rk(58)*O3*OLE +.35*rk(59)*NO3*OLE
     &  +.95*rk(82)*ETOH*OH +1.*rk(83)*ETOH*NO3
     &  +1.*rk(93)*ALDX +1.14*rk(94)*IOLE*O
     &  +1.2*rk(95)*IOLE*OH +.6*rk(96)*IOLE*O3
     &  +1.09*rk(97)*IOLE*NO3 +1.*rk(98)*CXO3*NO
     &  +1.*rk(101)*CXO3*C2O3 +1.*rk(103)*PANX*OH
     &  +.252*rk(105)*OH*ISPD +.02*rk(106)*O3*ISPD
     &  +.067*rk(108)*ISPD
      if (LPHCH) Rate(kPACT)=FPA*sink*ACET
      Rate(kACET) = Source + FSA*Sink*ACET
      Sink =   - rk(60)*O  - rk(61)*OH  - rk(62)*O3
      Source = 0.
      Rate(kETH) = Source + Sink*ETH
      Sink =   - rk(66)*OH  - rk(67)*NO3
      Source = .36*rk(63)*TOL*OH +1.*rk(65)*TO2
     &  +.2*rk(72)*OH*XYL
      Rate(kCRES) = Source + Sink*CRES
      Sink =   - rk(73)*OH  - rk(74)
      Source = .2*rk(71)*OPEN*O3 +.8*rk(72)*OH*XYL
     &  +.168*rk(105)*OH*ISPD +.85*rk(106)*O3*ISPD
      Rate(kMGLY) = Source + Sink*MGLY
      Sink =   - rk(69)  - rk(70)*OH  - rk(71)*O3
      Source = .9*rk(64)*TO2*NO +.3*rk(66)*OH*CRES
      Rate(kOPEN) = Source + Sink*OPEN
      Sink =   - rk(30)  - rk(31)*OH
      Source = 1.*rk(29)*HO2*NO2
      Rate(kPNA) = Source + Sink*PNA
      Sink =   - rk(48)
      Source = 1.*rk(47)*C2O3*NO2
      Rate(kPAN) = Source + Sink*PAN
      Sink =   - rk(36)*OH
      Source = 1.*rk(36)*OH*CO +1.*rk(37)*HCHO*OH
     &  +1.*rk(38)*HCHO +1.*rk(39)*HCHO
     &  +1.*rk(40)*HCHO*O +1.*rk(41)*HCHO*NO3
     &  +1.*rk(45)*ACET +.3*rk(56)*O*OLE
     &  +.33*rk(58)*O3*OLE +1.*rk(60)*O*ETH
     &  +.42*rk(62)*O3*ETH +1.*rk(69)*OPEN
     &  +2.*rk(70)*OPEN*OH +.69*rk(71)*OPEN*O3
     &  +1.*rk(74)*MGLY +.066*rk(77)*O3*ISOP
     &  +1.*rk(93)*ALDX +.1*rk(94)*IOLE*O
     &  +.25*rk(96)*IOLE*O3 +.334*rk(105)*OH*ISPD
     &  +.225*rk(106)*O3*ISPD +.643*rk(107)*NO3*ISPD
     &  +.333*rk(108)*ISPD
      Rate(kCO) = Source + Sink*CO
      Sink =   - rk(23)  - rk(24)*OH  - rk(25)*HNO2
     &   - rk(25)*HNO2
      Source = 2.*rk(21)*NO*NO2*H2O +1.*rk(22)*NO*OH
      Rate(kHNO2) = Source + Sink*HNO2
      Sink =   - rk(34)  - rk(35)*OH
      Source = 1.*rk(32)*HO2*HO2 +1.*rk(33)*HO2*HO2*H2O
      Rate(kH2O2) = Source + Sink*H2O2
      Sink =   - rk(27)*OH
      Source = 2.*rk(18)*N2O5*H2O +1.*rk(26)*NO2*OH
     &  +1.*rk(41)*HCHO*NO3 +1.*rk(44)*ACET*NO3
     &  +1.*rk(67)*CRES*NO3 +1.*rk(83)*ETOH*NO3
     &  +1.*rk(85)*MEOH*NO3 +1.*rk(92)*ALDX*NO3
     &  +.075*rk(107)*NO3*ISPD
      Rate(kHNO3) = Source + Sink*HNO3
      Sink =   - rk(75)*O  - rk(76)*OH  - rk(77)*O3
     &   - rk(78)*NO3  - rk(109)*NO2
      Source = 0.
      Rate(kISOP) = Source + Sink*ISOP
      Sink =   - rk(111)*OH  - rk(112)
      Source = 0.
      if (LSO2) Rate(kSO2) = Source + Sink*SO2
      Sink = 0.
      Source = 1.*rk(111)*SO2*OH +1.*rk(112)*SO2
      if (LSO2) Rate(kSULF) = Source + Sink*SULF
      Sink =   - rk(84)*OH  - rk(85)*NO3
      Source = 0.
      if (LMEOH) Rate(kMEOH) = Source + Sink*MEOH
      Sink =   - rk(82)*OH  - rk(83)*NO3
      Source = 0.
      if (LETOH) Rate(kETOH) = Source + Sink*ETOH
      Sink =   - rk(110)*OH
      Source = 0.
      if (LMTBE) Rate(kMTBE) = Source + Sink*MTBE
      Sink = 0.
      Source = 1.*rk(68)*CRO*NO2
      if (LNPHN) Rate(kNPHN) = Source + Sink*NPHN
      Sink =   - rk(90)*O  - rk(91)*OH  - rk(92)*NO3
     &   - rk(93)
      Source = .05*rk(52)*PAR*OH +.5*rk(53)*ROR
     &  +.39*rk(56)*O*OLE +.62*rk(57)*OH*OLE
     &  +.31*rk(58)*O3*OLE +.56*rk(59)*NO3*OLE
     &  +.22*rk(61)*OH*ETH +.03*rk(71)*OPEN*O3
     &  +.15*rk(77)*O3*ISOP +.8*rk(78)*NO3*ISOP
     &  +.011*rk(82)*ETOH*OH +.76*rk(94)*IOLE*O
     &  +.8*rk(95)*IOLE*OH +.4*rk(96)*IOLE*O3
     &  +.73*rk(97)*IOLE*NO3 +.021*rk(105)*OH*ISPD
     &  +.357*rk(107)*NO3*ISPD +.8*rk(109)*NO2*ISOP
      Rate(kALDX) = Source + Sink*ALDX
      Sink =   - rk(94)*O  - rk(95)*OH  - rk(96)*O3
     &   - rk(97)*NO3
      Source = 0.
      Rate(kIOLE) = Source + Sink*IOLE
      Sink =   - rk(100)  - rk(103)*OH
      Source = 1.*rk(99)*CXO3*NO2
      Rate(kPANX) = Source + Sink*PANX
      Sink =   - rk(51)*OH
      Source = 0.
      Rate(kCH4) = Source + Sink*CH4
      Sink = 0.
      Source = 1.*rk(55)*NO2*ROR+.8*rk(78)*NO3*ISOP +1.*rk(81)*XO2N*NO
     &  +.85*rk(107)*NO3*ISPD +.8*rk(109)*NO2*ISOP
      if (.not.lNPHN) Source = Source + 1.*rk(68)*CRO*NO2
      if (LNITR) Rate(kNTR) = Source + Sink*NTR
      Sink =   - rk(105)*OH  - rk(106)*O3  - rk(107)*NO3
     &   - rk(108)
      Source = .75*rk(75)*O*ISOP +.912*rk(76)*OH*ISOP
     &  +.65*rk(77)*O3*ISOP +.2*rk(78)*NO3*ISOP
     &  +.2*rk(109)*NO2*ISOP
      if (LISOP) Rate(kISPD) = Source + Sink*ISPD
c
c     *** zero out jac
c
       do i=1,nospec
         jac(i, i) = 0.
       end do
c
c      Calculating the Jacobian for state Species
c
      JAC(kOLE, kOLE) =  - rk(56)*O - rk(57)*OH
     $  - rk(58)*O3 - rk(59)*NO3
      JAC(kPAR, kPAR) =  - rk(52)*OH +(-.11)*rk(52)*OH
      JAC(kTOL, kTOL) =  - rk(63)*OH
      JAC(kXYL, kXYL) =  - rk(72)*OH
      JAC(kHCHO, kHCHO) =  - rk(37)*OH - rk(38)
     $  - rk(39) - rk(40)*O
     $  - rk(41)*NO3
      JAC(kACET, kACET) =  - rk(42)*O - rk(43)*OH
     $  - rk(44)*NO3 - rk(45)
      JAC(kETH, kETH) =  - rk(60)*O - rk(61)*OH
     $  - rk(62)*O3
      JAC(kCRES, kCRES) =  - rk(66)*OH - rk(67)*NO3
      JAC(kMGLY, kMGLY) =  - rk(73)*OH - rk(74)
      JAC(kOPEN, kOPEN) =  - rk(69) - rk(70)*OH
     $  - rk(71)*O3
      JAC(kPNA, kPNA) =  - rk(30) - rk(31)*OH
      JAC(kPAN, kPAN) =  - rk(48)
      JAC(kCO, kCO) =  - rk(36)*OH +1.*rk(36)*OH
      JAC(kHNO2, kHNO2) =  - rk(23) - rk(24)*OH
     $  - rk(25)*HNO2 - rk(25)*HNO2
     $  - rk(25)*HNO2 - rk(25)*HNO2
      JAC(kH2O2, kH2O2) =  - rk(34) - rk(35)*OH
      JAC(kHNO3, kHNO3) =  - rk(27)*OH
      if (LISOP) JAC(kISOP, kISOP) =  - rk(75)*O - rk(76)*OH
     $  - rk(77)*O3 - rk(78)*NO3
     $  - rk(109)*NO2
      if (LSO2) JAC(kSO2, kSO2) =  - rk(111)*OH - rk(112)
      if (LMEOH) JAC(kMEOH, kMEOH) =  - rk(84)*OH - rk(85)*NO3
      if (LETOH) JAC(kETOH, kETOH) =  - rk(82)*OH - rk(83)*NO3
      if (LMTBE) JAC(kMTBE, kMTBE) =  - rk(110)*OH
      JAC(kALDX, kALDX) =  - rk(90)*O - rk(91)*OH
     $  - rk(92)*NO3 - rk(93)
      JAC(kIOLE, kIOLE) =  - rk(94)*O - rk(95)*OH
     $  - rk(96)*O3 - rk(97)*NO3
      JAC(kPANX, kPANX) =  - rk(100) - rk(103)*OH
      JAC(kCH4, kCH4) =  - rk(51)*OH
      if (LISOP) JAC(kISPD, kISPD) =  - rk(105)*OH - rk(106)*O3
     $  - rk(107)*NO3 - rk(108)
c
      RETURN
      END
