      subroutine solar (sla,slo,tz,iy,im,id,time,zcoef)
c
c     *** (c) Copr. 1992  Systems Applications, Inc.  San Rafael, CA
c
c$Log: solar.f,v $
c  Revision 1.2  1994/02/10  21:00:35  tcm
c  Cosmetic revisions to code by gem, syw, tcm
c
c
c     
c     *** calculates solar zenith angle based on date, time, and lat/lon.
c***
c***  sla...  latitude (deg)  south = minus
c***  slo...  longitude (deg)  east = minus
c***  tz...  time zone
c***  iy..  year
c***  im..  month
c***  id..  day
c***  time.. local standard time in hours and minutes.
c***  1:30 pm = 1330  ** standard time **
c***  zcoef..  returned value = cos(zenith angle) during day, 0 at night
c***
      dimension md(11)
      data md/31,29,31,30,31,30,2*31,30,31,30/
      data a,b,c,siga/0.15,3.885,1.253,279.9348/
      rad=572957.75913e-4
      sdec=39784.988432e-5
      re=1.
      if(slo.lt.0.) re=-1.
      kz=ifix(tz)
      tc=tz-float(kz)*re
      tzz=float(kz)*re
      slb=sla/rad
      k=id
      timh=time/100.
      i=ifix(timh)
      timloc=(timh-float(i))/.6+float(i)+tc
      imc=im-1
      if(imc.lt.1) go to 20
      do 10 i=1,imc
   10 k=k+md(i)
   20 leap=1
      nl=mod(iy,4)
      if(nl.lt.1) leap=2
      smer=tzz*15.
      tk=((smer-slo)*4.)/60.
      kr=1
      if(k.ge.61.and.leap.lt.2) kr=2
      dad=(timloc+tzz)/24.
      dad=dad+float(k)-float(kr)
      df=dad*360./365.242
      de=df/rad
      desin=sin(de)
      decos=cos(de)
      desin2=sin(de*2.)
      decos2=cos(de*2.)
      sig=siga+df+1.914827*desin-0.079525*decos+0.019938*desin2-0.00162*
     &decos2
      sig=sig/rad
      decsin=sdec*sin(sig)
      effdec=asin(decsin)
      eqt=0.12357*desin-0.004289*decos+0.153809*desin2+0.060783*decos2
      tst=tk+timloc-eqt
      hrangl=abs(tst-12.)*15.
      hrangl=hrangl/rad
      solsin=decsin*sin(slb)+cos(effdec)*cos(slb)*cos(hrangl)
      zcoef=solsin
      zcoef=amax1(0.,zcoef)
      return
      end
