c
c  parameters for point sources
c
c$Log: stack.cmd,v $
c  Revision 1.5  1999/05/12  16:40:50  gem
c  added logical flags for temporally varying stack temps
c
c  Revision 1.4  1999/05/12  00:03:40  gem
c  added temporally varying stack temps
c
c  Revision 1.3  1994/08/04  14:30:34  tcm
c  Added flowrat variable to common /stack/
c  CAE 7/6/94
c
c  Revision 1.2  94/02/10  21:05:33  tcm
c  Cosmetic revisions to code by gem, syw, tcm
c  
c
c
c
c        stkht  -- stack height in meters
c        
c        stkd   -- stack diameter in meters.  if this is read
c                  as < 0 in the input, its absolute value will
c                  be used and the source will be designated to
c                  use pig treatment (i.e., pflag will be set true).
c
c        temps  -- stack temperature in degrees k
c
c        vexit  -- stack exit velocity internally in meters/second,
c                  converted from meters/hour entered in input file.
c
c        ptemis -- emissions rates for each emitted species in
c                  moles/min internally, converted from moles/hour
c                  on input file.
c
c        plong, plat -- location of source in longitude and latitude
c                       or if lcart is true in grid units internally, 
c                       converted from utm coordinates in meters on
c                       input file.
c
c        heff   -- effective plume height in meters calculated 
c                  internally by beh084
c
c        pflag  -- if true, this source will be treated by pig
c
c        prflg  -- if true, fully reactive chemistry will be done
c                  on this pig source.  if false, only photostationary
c                  chemistry will be done on this pig source.  if
c                  pflag is false for this source, this flag will 
c                  be ignored.
c
c       flowrat -- volumetric flow rate (m3/hr)
c
c       stktmp  -- temporally varying stack temps (K)
c
c       lstkt   -- if true, this source uses temporally varying stack temp
c
c        nopts  -- number of point sources
c
      common /stack/ stkht(mxsrc),stkd(mxsrc),temps(mxsrc),
     &               vexit(mxsrc), ptemis(mxemit,mxsrc), 
     &               plong(mxsrc), plat(mxsrc),
     &               heff(mxsrc), pflag(mxsrc), prflg(mxsrc),
     &               flowrat(mxsrc), lstkt(mxsrc), stktmp(mxsrc),
     &               nopts
      logical pflag, prflg, lstkt
