      subroutine termsf(nxf,nyf,nzf,nsp,ifine,rainf,htf,temprf,
     &                  ctlonf,ctlatf,
     &                  decayf,depvelf,cncf,deltat,time,ndate)
c
c     *** (c) Copr. 1992  Systems Applications, Inc.  San Rafael, CA
c
c$Log: termsf.f,v $
c  Revision 1.4  1999/12/21  19:28:45  tcm
c  Renamed com3 include file to comd3.
c
c  Revision 1.3  1998/11/04  02:03:13  tcm
c  Revised date treatment.\
c
c  Revision 1.2  94/02/10  21:01:55  tcm
c  Cosmetic revisions to code by gem, syw, tcm
c  
c
c
c----------------------------------------------------------------
c     as in terms except decayf is calculated from fine grid data
c     and accumulated deposition is not calculated on the fine grid.
c     also, variables in terms that serve only to hold current data 
c     for diagnostics (or whatever), such as wepos and rchm are 
c     excluded
c-----------------------------------------------------------------
c
      include 'parm.cmd'
      include 'parchm.cmd'
      include 'parfin.cmd'
      parameter (mxst2f = mxspec*mxfz)
      include 'deffin.cmd'
      include 'comuam.cmd'
      include 'latlon.cmd'
      include 'comd3.cmd'
      include 'comchem.cmd'
c
c     rdecay- decay rate due to wet deposition (species,layers)
c
      dimension decayf(nxf,nyf,nsp,nzf),depvelf(nxf,nyf,nsp)
      dimension rainf(nxf,nyf),htf(nxf,nyf,nzf)
     &,         temprf(nxf,nyf,nsp)
      dimension ctlonf(nxf,nyf), ctlatf(nxf,nyf)
      dimension rdecay(mxspec,mxfz)
      dimension cncf(nxf,nyf,nsp,nzf)
c
      data rrchem/0.0/
      data rdecay/mxst2f*0.0/
c
c
c     convert date to day,month,year
c
      write(*,4000) time,ndate,deltat
 4000 format(' enter termsf ',f10.1,i10,f10.2)
      call jtocal(ndate,ncdate)
      nd=mod(ncdate,100) 
      num=ncdate/100
      nm=mod(num,100)
      ny=num/100
c-------------------------------------------------------------
c     if using linear so2/so4 chemistry calculate chemical
c     reaction rate based on solar zenith angle. first, the
c     lat and long limits of the particular fine grid need
c     to be calculated
c-------------------------------------------------------------
      wlongf=wlong+float(ixfb(ifine)-1)*(elong-wlong)/float(nox)
      elongf=wlong+float(ixfe(ifine))*(elong-wlong)/float(nox)
      slatf=slat+float(jyfb(ifine)-1)*(nlat-slat)/float(noy)
      nlatf=slat+float(jyfe(ifine))*(nlat-slat)/float(noy)
c
      do 100 j=2,nyf-1
        do 90 i=2,nxf-1
          if (lchem) go to 40
c
          rllng=-ctlonf(i,j)
          rllt=ctlatf(i,j)
c
c     use time at beginning of time step for solar zenith angle
c
          ztime=time
          call solar(rllt,rllng,tz,ny,nm,nd,ztime,zcoef)
c
c  calculate chem reaction rate as a fraction of peak rate
c    +constant rate
c
          rrchem=(pkrchm-crchem)*(zcoef/zmax)+crchem
   40     continue
c
c     calculate wet depostion if neccesary
c
          if (lwet) call wetdepf(i,j,nxf,nyf,nzf,nsp,cncf,rainf
     &,                      htf,temprf,depvelf,rdecay,deltat)
c
          do 61 k=1,nzf
            do 60 isp=1,nsp
              decayf(i,j,isp,k)=-rdecay(isp,k)
   60       continue
   61     continue
          if (lchem) go to 80
          do 70 k=1,nzf
            decayf(i,j,1,k)=decayf(i,j,1,k)-rrchem
            decayf(i,j,2,k)=decayf(i,j,2,k)
     &               +1.5*rrchem*cncf(i,j,1,k)/cncf(i,j,2,k)
   70     continue
   80     continue
c---------------------------------------------------------------
c     no updating of layer heights necessary since they are
c     interpolated from updated coarse grid heights in aaamain
c---------------------------------------------------------------
   90   continue
  100 continue
      write(*,4100)
 4100 format(' leave termsf')
      return
      end
