      subroutine tirate 
c
c     *** (c) Copr. 1992  Systems Applications, Inc.  San Rafael, CA
c
c$Log: tirate.f,v $
c  Revision 1.3  1999/12/21  19:28:46  tcm
c  Renamed com3 include file to comd3.
c
c  Revision 1.2  1994/02/10  21:01:59  tcm
c  Cosmetic revisions to code by gem, syw, tcm
c
c
c
c
c
c--input variables
c         nreact    i  no of gas phase reactions
c
c--output variables
c         rkt       r  calculated gas phase rate constants
c         aqrkt     r  calculated aqueous phase rate constants
c         ktt       r  calculated equilibrium constants
c
c--local variables
c         tterm     r  -(1/tcell - 1/tref)
c
c--routines called
c         none
c
c--called by
c         
c
      include 'parchm.cmd'
      include 'comchem.cmd'
      include 'comd3.cmd'
      include 'comtdr.cmd'
c
c***********************************************************************
c
c     ***  produce lookup table for temperature-dependent rate constants
c
c            rk = rkn * exp(-(1/t - 1/298)*acten)
c
c
      dimension rk3(mxgrx)
c
c
      do 600 it = 1,100
        temp = it + 249.
        tterm = 1./298. - 1./temp
c
        do 250 i=1,nreact
          if (lphot(i)) goto 250
          if ((.not.ltdep(i)).or.(temp.eq.298)) then
          rkt(it,i) = rkn(i)
        else 
          rkt(it,i) = rkn(i) * exp(acten(i)*tterm)
        endif
        if(lpdep(i)) rk3t(it,i) = rk3(i) * exp(acten3(i)*tterm)
  250   continue
c
c  calculate new equilibrium constant values
c
  450   do 500 i= 1, naqeq
          ktt(it,i) = k0(i) * exp(dhor(i)*tterm)
  500   continue
c
  600 continue
c
      return
      end
