      subroutine trjstp(mmx,mmy,mmz,nxg,nyg,nzg,u,v,hg,xcel,ycel,
     &                  xg,yg,height,dtrem,dtc,dels,ucomp,vcomp,
     &                  ix,jy,kz,idiag)
c
c     *** (c) Copr. 1992  Systems Applications, Inc.  San Rafael, CA
c
c$Log: trjstp.f,v $
c  Revision 1.2  1994/02/10  21:02:07  tcm
c  Cosmetic revisions to code by gem, syw, tcm
c
c
c
c
c  move a puff along a trajectory until a cell edge is reached
c  or until requested time step is completed (tcm, cae 11/12/91)
c
      include 'advec.cmd'
      dimension u(mmx,mmy,mmz), v(mmx,mmy,mmz), hg(mmx,mmy,mmz)
c
c   get current layer
c
      do 10 k=1,nzg
        if (height .lt. hg(ix,jy,k)) then
          kz = k
          go to 20
        endif
   10 continue
c
c  calculate horizontal wind components
c
   20 if (lstagr) then 
        ucomp = .5*(u(ix,jy,kz) + u(ix-1,jy,kz))
        vcomp = .5*(v(ix,jy,kz) + v(ix,jy-1,kz))
      else
        ucomp = u(ix,jy,kz)
        vcomp = v(ix,jy,kz)
      endif
c
c   calculate vertical wind component
c
      wp1 = 0.
      do 50 k=1,kz
        wm1 = wp1
        d=hg(ix,jy,k)
        if (k.gt.1) d=hg(ix,jy,k)-hg(ix,jy,k-1)
c
        if (lstagr) then
c
          if (jy.eq.1) then
            dy=0.
          else
            dy=(v(ix,jy,k)-v(ix,jy-1,k))/ycel
          endif
c
          if (ix.eq.1) then
            dx=0.
          else
            dx=(u(ix,jy,k)-u(ix-1,jy,k))/xcel
          endif
c
        else
c
          if (jy.le.1) then
            dy=(v(ix,2,k)-v(ix,1,k))/ycel
          else if (jy.ge.nyg) then
            dy=(v(ix,nyg,k)-v(ix,nyg-1,k))/ycel
          else
            dy=(v(ix,jy+1,k)-v(ix,jy-1,k))/(2.0*ycel)
          endif
c
          if (ix.le.1) then
            dx=(u(2,jy,k)-u(1,jy,k))/xcel
          else if (ix.ge.nxg) then
            dx=(u(nxg,jy,k)-u(nxg-1,jy,k))/xcel
          else
            dx=(u(ix+1,jy,k)-u(ix-1,jy,k))/(2.0*xcel)
          endif
c
        endif
c
        div=dx+dy
        wp1 = -div*d + wm1
   50 continue
c
      if (kz .eq. 1) then
        hblow = 0.
      else
        hblow = hg(ix,jy,kz-1)
      endif
      ff = (height-hblow)/(hg(ix,jy,kz)-hblow)
      ff2 = 1. - ff
      wcomp = ff2*wm1 + ff*wp1
c
c  set minimum speeds
c
      if (abs(ucomp) .lt. .001) ucomp = .001
      if (abs(vcomp) .lt. .001) vcomp = .001
      if (abs(wcomp) .lt. 1.e-6) wcomp = 1.e-6
c
c  calculate size of step that will reach edge of cell
c
      if (ucomp .lt. 0.) then 
        dtx = (float(ix-1)*xcel - xg)/ucomp
      else
        dtx = (float(ix)*xcel - xg)/ucomp
      endif
c
      if (vcomp .lt. 0.) then
        dty = (float(jy-1)*ycel - yg)/vcomp
      else
        dty = (float(jy)*ycel - yg)/vcomp
      endif
c
      if (wcomp .lt. 0.) then
        dtz = (hblow - height)/wcomp
      else
        dtz = (hg(ix,jy,kz) - height)/wcomp
      endif
c
      dtc = amin1(dtx,dty,dtz,dtrem)
c
c  make sure we get somewhere
c
      dtc = 1.001*amax1(dtc,.1)
c
c  get new positions
c
      delx = ucomp*dtc
      dely = vcomp*dtc
      delz = wcomp*dtc
      xg = xg + delx
      yg = yg + dely
      height = height + delz
      if (height .lt. 0.005) height = 0.005
c
c   calculate i and j indexes on grid
c
      ix = ifix(xg/xcel) + 1
      jy = ifix(yg/ycel) + 1
c
c   get current layer
c
      do 101 k=1,nzg
        if (height .lt. hg(ix,jy,k)) then
          kz = k
          go to 201
        endif
  101 continue
c
c  calculate the distance increment 
c
  201 dels = sqrt(delx**2 + dely**2)
c
      return
      end
