      subroutine xmsflo(mdx,mdy,mdz,mdspc,nxg,nyg,nzg,delx,dely,cnca,
     &                  hta,ua,va,etaa,delt,ifine)
c
c     *** (c) Copr. 1992  Systems Applications, Inc.  San Rafael, CA
c
c$Log: xmsflo.f,v $
c  Revision 1.2  1994/02/10  21:03:06  tcm
c  Cosmetic revisions to code by gem, syw, tcm
c
c
c
c
c  a calculation of mass flux across region boundaries based on coarse
c  grid variables.  (tcm, 5/6/93)
c
c
      include 'parm.cmd'
      include 'parchm.cmd'
      include 'parfin.cmd'
      include 'deffin.cmd'
      include 'comuam.cmd'
      include 'balanc.cmd'
      include 'advec.cmd'
      dimension cnca(mdx,mdy,mdspc,mdz), hta(mdx,mdy,mdz),
     &          ua(mdx,mdy,mdz), va(mdx,mdy,mdz), etaa(mdx,mdy,mdz)
      dimension delx(mdy)
c
c
c  get start and end cells in coarse grid of this fine grid
c
      ix1 = ixfb(ifine)
      ix2 = ixfe(ifine)
      jy1 = jyfb(ifine)
      jy2 = jyfe(ifine)
c
c total fluxes across lateral boundaries for all layers
c
      do 200 k=1,nzg
        do 150 j=jy1,jy2
c
c       calculate boundary inflow and outflow for west bnd
c
          i = ix1
          if (k .eq. 1) then
            delh = 0.5*(hta(i,j,k)+hta(i-1,j,k))
          else
            delh = 0.5*(hta(i,j,k)-hta(i,j,k-1)
     &                  +hta(i-1,j,k)-hta(i-1,j,k-1))
          endif
          bfac = delt*dely*delh*1000.
          if (lstagr) then
            wb = ua(i-1,j,k)
          else
            wb = .5*(ua(i-1,j,k)+ua(i,j,k))
          endif
          do 120 l=1,nospec
            if (wb .gt. 0.) then
              cc = cnca(i-1,j,l,k)
                xbcflo(l,1,4,ifine) = xbcflo(l,1,4,ifine) + 
     &              wb*cc*bfac
            else
              cc = cnca(i,j,l,k)
              xbcflo(l,2,4,ifine) = xbcflo(l,2,4,ifine) - 
     &                  wb*cc*bfac
            endif
  120     continue
c
c             calculate boundary inflow and outflow for east bnd
c
          i = ix2
          if (k .eq. 1) then
            delh = 0.5*(hta(i,j,k)+hta(i+1,j,k))
          else
            delh = 0.5*(hta(i,j,k)-hta(i,j,k-1)
     &             +hta(i+1,j,k)-hta(i+1,j,k-1))
          endif
          bfac = delt*dely*delh*1000.
          if (lstagr) then
            wb = ua(i,j,k)
          else
            wb = .5*(ua(i,j,k)+ua(i+1,j,k))
          endif
          do 140 l=1,nospec
            if (wb .lt. 0.) then
              cc = cnca(i+1,j,l,k)
              xbcflo(l,1,3,ifine) = xbcflo(l,1,3,ifine) - 
     &              wb*cc*bfac
            else
              cc = cnca(i,j,l,k)
              xbcflo(l,2,3,ifine) = xbcflo(l,2,3,ifine) + 
     &               wb*cc*bfac
            endif
  140     continue
  150   continue
c
c             calculate boundary inflow and outflow for south bnd
c
        do 180 i=ix1,ix2
          j = jy1
          if (k .eq. 1) then
            delh = 0.5*(hta(i,j,k)+hta(i,j-1,k))
          else
            delh = 0.5*(hta(i,j,k)-hta(i,j,k-1)
     &                 +hta(i,j-1,k)-hta(i,j-1,k-1))
          endif
          bfac = delt*delx(j)*delh*1000.
          if (lstagr) then
            wb = va(i,j-1,k)
          else
            wb = .5*(va(i,j,k)+va(i,j-1,k))
          endif
          do 160 l=1,nospec
            if (wb .gt. 0.) then
              cc = cnca(i,j-1,l,k)
              xbcflo(l,1,2,ifine) = xbcflo(l,1,2,ifine) + 
     &                 wb*cc*bfac
            else
              cc = cnca(i,j,l,k)
              xbcflo(l,2,2,ifine) = xbcflo(l,2,2,ifine) - 
     &                 wb*cc*bfac
            endif
  160     continue
c
c       calculate boundary inflow and outflow for north bnd
c
          j = jy2
          if (k .eq. 1) then
            delh = 0.5*(hta(i,j,k)+hta(i,j+1,k))
          else
            delh = 0.5*(hta(i,j,k)-hta(i,j,k-1)
     &                 +hta(i,j+1,k)-hta(i,j+1,k-1))
          endif
          bfac = delt*delx(j)*delh*1000.
          if (lstagr) then
            wb = va(i,j,k)
          else
            wb = .5*(va(i,j,k)+va(i,j+1,k))
          endif
          do 170 l=1,nospec
            if (wb .lt. 0.) then
              cc = cnca(i,j+1,l,k)
              xbcflo(l,1,1,ifine) = xbcflo(l,1,1,ifine) - 
     &                      wb*cc*bfac
            else
              cc = cnca(i,j,l,k)
              xbcflo(l,2,1,ifine) = xbcflo(l,2,1,ifine) + 
     &                     wb*cc*bfac
            endif
  170     continue
  180   continue
  200 continue
c
c  calculate flow through top
c
      vf1 = delt*dely*1000.
      do 300 j=jy1,jy2
        vf2 = vf1*delx(j)
        do 290 i=ix1,ix2
          do 280 l=1,nospec
            vfac = -etaa(i,j,nzg)*vf2
            if (vfac .ge. 0.) then
              xtpflo(l,2,ifine) = xtpflo(l,2,ifine) 
     &                            + vfac*cnca(i,j,l,nzg)
            else
              xtpflo(l,1,ifine) = xtpflo(l,1,ifine) - vfac*caloft(l)
            endif
  280     continue
  290   continue
  300 continue
c
      return
c
      end
